// added for reading years & names from website
using System.IO;
using System.Net;
using System.Threading;
using System.Text;

using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;

namespace SAS.CustomTasks.HurricaneTracker
{
	/// <summary>
	/// Summary description for CustomTaskForm1.
	/// </summary>
	public class CustomTaskForm1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbYear;
		private System.Windows.Forms.Label label3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox cmbNames;
		private System.Windows.Forms.Label lblDescription;
		private System.Windows.Forms.LinkLabel linkWS;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblDetails;
		private System.Windows.Forms.Button btnDetails;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox txtYear;
		private System.Windows.Forms.TextBox txtNames;

		// 1950 was first year for "named" storms
		public const int	FIRST_YEAR=1950;

		// panel sizes for hiding and showing details
		public const int	DLGSM_WIDTH=304, DLGSM_HEIGHT=296;
		public const int	DLGLG_WIDTH=488, DLGLG_HEIGHT=584;

		private ArrayList namesArray = new ArrayList();

		#region Properties for this add-in task
		private string _sYear = "";
		public string sYear
		{
			set	{ _sYear = value; }
			get { return _sYear; }
		}
	
		private string _sName = "";
		public string sName
		{
			set	{ _sName = value; }
			get { return _sName; }
		}

		private bool _bProxy = false;
		public bool bProxy
		{
			set { _bProxy = value; }
			get { return _bProxy; }
		}
	
		private string _sProxy = "";
	
		public string sProxy
		{
			set	{ _sProxy = value; }
			get { return _sProxy; }
		}
		#endregion

		private bool	bShowDetails=false;

		public CustomTaskForm1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.cmbYear = new System.Windows.Forms.ComboBox();
			this.cmbNames = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.lblDescription = new System.Windows.Forms.Label();
			this.linkWS = new System.Windows.Forms.LinkLabel();
			this.label1 = new System.Windows.Forms.Label();
			this.btnDetails = new System.Windows.Forms.Button();
			this.lblDetails = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.txtYear = new System.Windows.Forms.TextBox();
			this.txtNames = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(312, 520);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(72, 23);
			this.btnOK.TabIndex = 14;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(392, 520);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 23);
			this.btnCancel.TabIndex = 15;
			this.btnCancel.Text = "Cancel";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "&Year:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// cmbYear
			// 
			this.cmbYear.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbYear.Location = new System.Drawing.Point(8, 72);
			this.cmbYear.MaxDropDownItems = 10;
			this.cmbYear.Name = "cmbYear";
			this.cmbYear.Size = new System.Drawing.Size(80, 21);
			this.cmbYear.TabIndex = 3;
			this.cmbYear.Visible = false;
			this.cmbYear.SelectedIndexChanged += new System.EventHandler(this.cmbYear_SelectedIndexChanged);
			// 
			// cmbNames
			// 
			this.cmbNames.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbNames.Location = new System.Drawing.Point(104, 72);
			this.cmbNames.MaxDropDownItems = 10;
			this.cmbNames.Name = "cmbNames";
			this.cmbNames.Size = new System.Drawing.Size(184, 21);
			this.cmbNames.TabIndex = 6;
			this.cmbNames.Visible = false;
			this.cmbNames.SelectedIndexChanged += new System.EventHandler(this.cmbNames_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(104, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(184, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "&Name:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// lblDescription
			// 
			this.lblDescription.Location = new System.Drawing.Point(8, 8);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(280, 32);
			this.lblDescription.TabIndex = 0;
			this.lblDescription.Text = "set in code";
			// 
			// linkWS
			// 
			this.linkWS.AutoSize = true;
			this.linkWS.Location = new System.Drawing.Point(8, 192);
			this.linkWS.Name = "linkWS";
			this.linkWS.Size = new System.Drawing.Size(197, 16);
			this.linkWS.TabIndex = 11;
			this.linkWS.TabStop = true;
			this.linkWS.Text = "weather.unisys.com/hurricane/atlantic/";
			this.linkWS.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			this.linkWS.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkWS_LinkClicked);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 176);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(280, 16);
			this.label1.TabIndex = 10;
			this.label1.Text = "This add-in reads hurricane data from:";
			// 
			// btnDetails
			// 
			this.btnDetails.Location = new System.Drawing.Point(8, 232);
			this.btnDetails.Name = "btnDetails";
			this.btnDetails.Size = new System.Drawing.Size(80, 23);
			this.btnDetails.TabIndex = 12;
			this.btnDetails.Text = "&Details >>>";
			this.btnDetails.Click += new System.EventHandler(this.btnDetails_Click);
			// 
			// lblDetails
			// 
			this.lblDetails.Location = new System.Drawing.Point(8, 264);
			this.lblDetails.Name = "lblDetails";
			this.lblDetails.Size = new System.Drawing.Size(464, 248);
			this.lblDetails.TabIndex = 13;
			this.lblDetails.Text = "set in code";
			this.lblDetails.Visible = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 104);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(280, 23);
			this.button1.TabIndex = 7;
			this.button1.Text = "&Retrieve \"Years\" and \"Names\" from website.";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(8, 136);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(88, 24);
			this.checkBox1.TabIndex = 8;
			this.checkBox1.Text = "use &proxy";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// textBox1
			// 
			this.textBox1.Enabled = false;
			this.textBox1.Location = new System.Drawing.Point(96, 136);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(192, 20);
			this.textBox1.TabIndex = 9;
			this.textBox1.Text = "http://inetgw.fyi.sas.com:80";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// txtYear
			// 
			this.txtYear.Location = new System.Drawing.Point(320, 168);
			this.txtYear.Name = "txtYear";
			this.txtYear.Size = new System.Drawing.Size(80, 20);
			this.txtYear.TabIndex = 2;
			this.txtYear.Text = "";
			this.txtYear.TextChanged += new System.EventHandler(this.txtYear_TextChanged);
			// 
			// txtNames
			// 
			this.txtNames.Location = new System.Drawing.Point(272, 224);
			this.txtNames.Name = "txtNames";
			this.txtNames.Size = new System.Drawing.Size(184, 20);
			this.txtNames.TabIndex = 5;
			this.txtNames.Text = "";
			this.txtNames.TextChanged += new System.EventHandler(this.txtNames_TextChanged);
			// 
			// CustomTaskForm1
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(474, 551);
			this.Controls.Add(this.txtNames);
			this.Controls.Add(this.txtYear);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.linkWS);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.lblDetails);
			this.Controls.Add(this.btnDetails);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblDescription);
			this.Controls.Add(this.cmbNames);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cmbYear);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "CustomTaskForm1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "set in code";
			this.Load += new System.EventHandler(this.CustomTaskForm1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void CustomTaskForm1_Load(object sender, System.EventArgs e)
		{
			lblDescription.Text = "Display a tracking map with the path of the selected hurricane.";
			lblDetails.Text = "The add-in goes to the above website and reads the data for the selected hurricane using the SAS 'filename' statement with the 'url' parameter specified." +
				"\r\n\r\nThe size of the plotted hurricane symbol is based on the wind speed.  The symbol is red if the storm is a hurricane and blue if the storm is less than a hurricane." +
				"\r\n\r\nFor the individual hurricane symbols chart tip/flyover-text is provided using title= annotate \"html=\" variable and href= in the \"html=\" variable is coded so that clicking on the symbol does a 'google' search on that particular hurricane." +
				"\r\n\r\nAn annotate data set is created for the longitude/latitude grid, using annotated lines, and then labels at the ends of the lines to show which gridline it is." +
				"\r\n\r\nTo get the annotated hurricane symbols and gridline to line up correctly on the map, the map and annotate data sets are combined together using \"GPROJECT\" with the 'robinson' projection.  Then the map and annotate data sets are separated and \"GMAP\" is used to draw the map, and annotate the hurricane path with the longitude/latitude grid on top of the map.  In the GMAP, the \"html=\" option is used to show the country names when the mouse is over the countries.";
			// start with no "details" size
			this.Size = new Size(DLGSM_WIDTH,DLGSM_HEIGHT);

			// restore task state
			checkBox1.Checked = bProxy;
			textBox1.Enabled = bProxy;
			textBox1.Text = sProxy;

			// the edit fields should be at the same position as the combo boxes
			txtYear.Location = cmbYear.Location;
			txtNames.Location = cmbNames.Location;

			// load task state
			txtYear.Text = sYear;
			txtNames.Text = sName;

			UpdateControls();
		}

		private void UpdateControls()
		{
			// we must have a year and name to work with
			if ( (sYear.Length == 4) && (sName.Length > 0) )
				btnOK.Enabled = true;
			else
				btnOK.Enabled = false;
		}

		private void cmbYear_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// update name combo with names for the selected year
			cmbNames.Items.Clear();
			int iYr=Convert.ToInt32(cmbYear.Text);
			StringCollection names = (StringCollection)namesArray[iYr - FIRST_YEAR];
			foreach ( string strTmp in names )
				cmbNames.Items.Add( strTmp );

			// select the first storm of that year, making sure there's one to select
			if ( cmbNames.Items.Count > 0 )
				cmbNames.SelectedIndex = 0;

			// update property from the UI
			sName = cmbNames.Text;
			sYear = cmbYear.Text;

			UpdateControls();
		}

		private void cmbNames_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// update property from the UI
			sName = cmbNames.Text;

			UpdateControls();
		}

		private void btnDetails_Click(object sender, System.EventArgs e)
		{
			// are the details currently displayed
			if ( bShowDetails )
			{
				// yes, turn them off then
				bShowDetails = false;
				this.Size = new Size(DLGSM_WIDTH,DLGSM_HEIGHT);
				btnDetails.Text = "&Details >>>";
				btnDetails.Size = new Size(80,23);
				lblDetails.Visible = false;
			}
			else
			{
				// nope, display them
				bShowDetails = true;
				this.Size = new Size(DLGLG_WIDTH,DLGLG_HEIGHT);
				btnDetails.Text = "<<< &Hide Details";
				btnDetails.Size = new Size(112,23);
				lblDetails.Visible = true;
			}
		}

		private void linkWS_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			// launch browser, going to the weater data site
			System.Diagnostics.Process.Start( "http://" + linkWS.Text );
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// this may take a while put up the hourglass
			Cursor c = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;

			// we'll try reading the values from the web site
			try 
			{

				// setup the address
				Uri myUri = new Uri("http://weather.unisys.com/hurricane/atlantic/tracks.atl");
				WebRequest myRequest = WebRequest.Create( myUri );

				// if we're using a proxy, be sure to set it
				if ( bProxy )
				{
					WebProxy myProxy=new WebProxy();
					Uri myPuri = new Uri(textBox1.Text);
					myProxy.Address = myPuri;
					myRequest.Proxy = myProxy;
				}

				// get the data from the website
				WebResponse myResponse = myRequest.GetResponse();
				Stream strm = myResponse.GetResponseStream();

				using (StreamReader sr = new StreamReader( strm )) 
				{
					// clear out our combo boxes
					cmbYear.Items.Clear();
					cmbNames.Items.Clear();

					string	sPrevYear = "";
					string	sLine, sYear, sName;
					int		iX = -1;

					while ( (sLine = sr.ReadLine()) != null) 
					{
						// years are preceded by a /
						if ( sLine[11] == '/' )
						{
							sYear = sLine.Substring( 12, 4 );

							// we want to start with 1950 (the first year for named storms)
							if ( Convert.ToInt32(sYear) < FIRST_YEAR )
								continue;

							// do we have a "new" year
							if ( sYear != sPrevYear )
							{
								// yep, let's add it, incr. our yr index
								cmbYear.Items.Add( sYear );
								++iX;
								// also create a new string collection to hold the storm names
								// for this year and add it to our big list
								StringCollection namesList = new StringCollection();
								namesArray.Add( namesList );
							}

							// remember this year for next time
							sPrevYear = sYear;

							// get and trim the next name
							sName = sLine.Substring( 35, 12 );
							sName = sName.TrimEnd( null );
							
							// we wan't to skip un-named storms
							if ( (sName == "NOT NAMED") || ((sName.Length > 6 ) && sName.Substring(0,7) == "SUBTROP") )
								continue;

							// get the string collection for our current year
							StringCollection names = (StringCollection)namesArray[iX];

							// add this storm to it
							names.Add(sName);
						}
					}
				}

				// select the first storm of the latest year
				cmbYear.SelectedIndex = (cmbYear.Items.Count - 1);
				cmbNames.SelectedIndex = 0;

				// turn off the edit fields and display the combo boxes
				txtYear.Visible = txtNames.Visible = false;
				cmbYear.Visible = cmbNames.Visible = true;

				// you only need to click this once
				button1.Enabled = false;
			}
    		catch (Exception ex) 
			{
				// let the user know we couldn't get the hurricane data
				MessageBox.Show( "Could not read hurricane names from web site.\r\n\r\nYou can manually enter the year and name in the boxes.\r\n\r\n\r\nNote:  You may need to use a proxy.\r\n\r\nError:\r\n" + ex.Message, "Hurricane Data Retrieval", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
			}

			// restore previous cursor
			Cursor.Current = c;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			// update property from the UI
			bProxy = checkBox1.Checked;

			// enable/disable edit field
			textBox1.Enabled = bProxy;
		}

		private void txtYear_TextChanged(object sender, System.EventArgs e)
		{
			// update property from the UI
			sYear = txtYear.Text;

			UpdateControls();
		}

		private void txtNames_TextChanged(object sender, System.EventArgs e)
		{
			// update property from the UI
			sName = txtNames.Text;

			UpdateControls();
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			// update property from the UI
			sProxy = textBox1.Text;
		}
	}
}
