using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

public class user32
{
	[DllImport("user32.dll")]
	public static extern bool MessageBeep(int soundtype);
}

namespace SAS.CustomTasks.LoanCompare
{
	/// <summary>
	/// Summary description for LoanCompareForm.
	/// </summary>
	public class LoanCompareForm : System.Windows.Forms.Form
	{
		CodeForm	_frmCode;
		private int	iLoanIndex = 1;		// 1 based, not zero
	
		#region Properties for this add-in task
		private LoanCompare _taskModel;
		public LoanCompare taskModel
		{
			set { _taskModel = value; }
		}
		#endregion

		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label31;
		private System.Windows.Forms.GroupBox gbAP1;
		private System.Windows.Forms.DateTimePicker dtpAP1;
		private System.Windows.Forms.DateTimePicker dtpAP2;
		private System.Windows.Forms.DateTimePicker dtpAP3;
		private System.Windows.Forms.Label lblAP1;
		private System.Windows.Forms.Label lblAP2;
		private System.Windows.Forms.Label lblAP3;
		private System.Windows.Forms.CheckBox ckbAP1;
		private System.Windows.Forms.CheckBox ckbOG4;
		private System.Windows.Forms.CheckBox ckbOG2;
		private System.Windows.Forms.CheckBox ckbOG3;
		private System.Windows.Forms.CheckBox ckbOG1;
		private System.Windows.Forms.GroupBox gbOG1;
		private System.Windows.Forms.Label lblOG0;
		private System.Windows.Forms.ComboBox cmbNumLoans;
		private System.Windows.Forms.Panel pnlL1;
		private System.Windows.Forms.Label lblL1AP3;
		private System.Windows.Forms.Label lblL1AP2;
		private System.Windows.Forms.Label lblL1AP1;
		private System.Windows.Forms.TextBox edtL1AP3;
		private System.Windows.Forms.TextBox edtL1AP2;
		private System.Windows.Forms.TextBox edtL1AP1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Panel pnlL2;
		private System.Windows.Forms.Label lblL2AP3;
		private System.Windows.Forms.Label lblL2AP2;
		private System.Windows.Forms.Label lblL2AP1;
		private System.Windows.Forms.TextBox edtL2AP3;
		private System.Windows.Forms.TextBox edtL2AP2;
		private System.Windows.Forms.TextBox edtL2AP1;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Panel pnlL3;
		private System.Windows.Forms.Label lblL3AP3;
		private System.Windows.Forms.Label lblL3AP2;
		private System.Windows.Forms.Label lblL3AP1;
		private System.Windows.Forms.TextBox edtL3AP3;
		private System.Windows.Forms.TextBox edtL3AP2;
		private System.Windows.Forms.TextBox edtL3AP1;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.Panel pnlL4;
		private System.Windows.Forms.Label lblL4AP3;
		private System.Windows.Forms.Label lblL4AP2;
		private System.Windows.Forms.Label lblL4AP1;
		private System.Windows.Forms.TextBox edtL4AP3;
		private System.Windows.Forms.TextBox edtL4AP2;
		private System.Windows.Forms.TextBox edtL4AP1;
		private System.Windows.Forms.Label label30;
		private System.Windows.Forms.RadioButton rbtL1;
		private System.Windows.Forms.RadioButton rbtL2;
		private System.Windows.Forms.RadioButton rbtL3;
		private System.Windows.Forms.RadioButton rbtL4;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.NumericUpDown spnAmtL1;
		private System.Windows.Forms.NumericUpDown spnAmtL2;
		private System.Windows.Forms.HScrollBar scrlAmount;
		private System.Windows.Forms.HScrollBar scrlMonths;
		private System.Windows.Forms.ComboBox cmbMonths;
		private System.Windows.Forms.ComboBox cmbInterest;
		private System.Windows.Forms.HScrollBar scrlInterest;
		private System.Windows.Forms.DateTimePicker dtpStart;
		private System.Windows.Forms.NumericUpDown spnMthsL1;
		private System.Windows.Forms.TextBox txtPayL1;
		private System.Windows.Forms.NumericUpDown spnIntL1;
		private System.Windows.Forms.NumericUpDown spnMthsL2;
		private System.Windows.Forms.TextBox txtPayL2;
		private System.Windows.Forms.NumericUpDown spnIntL2;
		private System.Windows.Forms.NumericUpDown spnAmtL3;
		private System.Windows.Forms.NumericUpDown spnMthsL3;
		private System.Windows.Forms.TextBox txtPayL3;
		private System.Windows.Forms.NumericUpDown spnIntL3;
		private System.Windows.Forms.NumericUpDown spnAmtL4;
		private System.Windows.Forms.NumericUpDown spnMthsL4;
		private System.Windows.Forms.TextBox txtPayL4;
		private System.Windows.Forms.NumericUpDown spnIntL4;
		private System.Windows.Forms.CheckBox ckbCode;
		private System.Windows.Forms.Label lblLastL1;
		private System.Windows.Forms.Label lblLastL2;
		private System.Windows.Forms.Label lblLastL3;
		private System.Windows.Forms.Label lblLastL4;
		private System.ComponentModel.IContainer components;

		public LoanCompareForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.rbtL1 = new System.Windows.Forms.RadioButton();
			this.rbtL2 = new System.Windows.Forms.RadioButton();
			this.label2 = new System.Windows.Forms.Label();
			this.scrlAmount = new System.Windows.Forms.HScrollBar();
			this.scrlMonths = new System.Windows.Forms.HScrollBar();
			this.cmbMonths = new System.Windows.Forms.ComboBox();
			this.cmbInterest = new System.Windows.Forms.ComboBox();
			this.scrlInterest = new System.Windows.Forms.HScrollBar();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.gbAP1 = new System.Windows.Forms.GroupBox();
			this.dtpAP1 = new System.Windows.Forms.DateTimePicker();
			this.label9 = new System.Windows.Forms.Label();
			this.dtpStart = new System.Windows.Forms.DateTimePicker();
			this.dtpAP2 = new System.Windows.Forms.DateTimePicker();
			this.dtpAP3 = new System.Windows.Forms.DateTimePicker();
			this.lblAP1 = new System.Windows.Forms.Label();
			this.lblAP2 = new System.Windows.Forms.Label();
			this.lblAP3 = new System.Windows.Forms.Label();
			this.gbOG1 = new System.Windows.Forms.GroupBox();
			this.lblOG0 = new System.Windows.Forms.Label();
			this.ckbOG4 = new System.Windows.Forms.CheckBox();
			this.ckbOG2 = new System.Windows.Forms.CheckBox();
			this.ckbOG3 = new System.Windows.Forms.CheckBox();
			this.ckbOG1 = new System.Windows.Forms.CheckBox();
			this.rbtL3 = new System.Windows.Forms.RadioButton();
			this.rbtL4 = new System.Windows.Forms.RadioButton();
			this.cmbNumLoans = new System.Windows.Forms.ComboBox();
			this.label31 = new System.Windows.Forms.Label();
			this.ckbAP1 = new System.Windows.Forms.CheckBox();
			this.pnlL1 = new System.Windows.Forms.Panel();
			this.spnAmtL1 = new System.Windows.Forms.NumericUpDown();
			this.spnMthsL1 = new System.Windows.Forms.NumericUpDown();
			this.lblL1AP3 = new System.Windows.Forms.Label();
			this.lblL1AP2 = new System.Windows.Forms.Label();
			this.lblL1AP1 = new System.Windows.Forms.Label();
			this.edtL1AP3 = new System.Windows.Forms.TextBox();
			this.edtL1AP2 = new System.Windows.Forms.TextBox();
			this.edtL1AP1 = new System.Windows.Forms.TextBox();
			this.lblLastL1 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtPayL1 = new System.Windows.Forms.TextBox();
			this.spnIntL1 = new System.Windows.Forms.NumericUpDown();
			this.pnlL2 = new System.Windows.Forms.Panel();
			this.spnAmtL2 = new System.Windows.Forms.NumericUpDown();
			this.spnMthsL2 = new System.Windows.Forms.NumericUpDown();
			this.lblL2AP3 = new System.Windows.Forms.Label();
			this.lblL2AP2 = new System.Windows.Forms.Label();
			this.lblL2AP1 = new System.Windows.Forms.Label();
			this.edtL2AP3 = new System.Windows.Forms.TextBox();
			this.edtL2AP2 = new System.Windows.Forms.TextBox();
			this.edtL2AP1 = new System.Windows.Forms.TextBox();
			this.lblLastL2 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.txtPayL2 = new System.Windows.Forms.TextBox();
			this.spnIntL2 = new System.Windows.Forms.NumericUpDown();
			this.pnlL3 = new System.Windows.Forms.Panel();
			this.spnAmtL3 = new System.Windows.Forms.NumericUpDown();
			this.spnMthsL3 = new System.Windows.Forms.NumericUpDown();
			this.lblL3AP3 = new System.Windows.Forms.Label();
			this.lblL3AP2 = new System.Windows.Forms.Label();
			this.lblL3AP1 = new System.Windows.Forms.Label();
			this.edtL3AP3 = new System.Windows.Forms.TextBox();
			this.edtL3AP2 = new System.Windows.Forms.TextBox();
			this.edtL3AP1 = new System.Windows.Forms.TextBox();
			this.lblLastL3 = new System.Windows.Forms.Label();
			this.label25 = new System.Windows.Forms.Label();
			this.txtPayL3 = new System.Windows.Forms.TextBox();
			this.spnIntL3 = new System.Windows.Forms.NumericUpDown();
			this.pnlL4 = new System.Windows.Forms.Panel();
			this.spnAmtL4 = new System.Windows.Forms.NumericUpDown();
			this.spnMthsL4 = new System.Windows.Forms.NumericUpDown();
			this.lblL4AP3 = new System.Windows.Forms.Label();
			this.lblL4AP2 = new System.Windows.Forms.Label();
			this.lblL4AP1 = new System.Windows.Forms.Label();
			this.edtL4AP3 = new System.Windows.Forms.TextBox();
			this.edtL4AP2 = new System.Windows.Forms.TextBox();
			this.edtL4AP1 = new System.Windows.Forms.TextBox();
			this.lblLastL4 = new System.Windows.Forms.Label();
			this.label30 = new System.Windows.Forms.Label();
			this.txtPayL4 = new System.Windows.Forms.TextBox();
			this.spnIntL4 = new System.Windows.Forms.NumericUpDown();
			this.button1 = new System.Windows.Forms.Button();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.ckbCode = new System.Windows.Forms.CheckBox();
			this.pnlL1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL1)).BeginInit();
			this.pnlL2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL2)).BeginInit();
			this.pnlL3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL3)).BeginInit();
			this.pnlL4.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL4)).BeginInit();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(624, 512);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 37;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(712, 512);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 38;
			this.btnCancel.Text = "Cancel";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(368, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Loan &amount:";
			// 
			// rbtL1
			// 
			this.rbtL1.Checked = true;
			this.rbtL1.Location = new System.Drawing.Point(400, 8);
			this.rbtL1.Name = "rbtL1";
			this.rbtL1.Size = new System.Drawing.Size(64, 24);
			this.rbtL1.TabIndex = 29;
			this.rbtL1.TabStop = true;
			this.rbtL1.Text = "Loan &1";
			this.rbtL1.CheckedChanged += new System.EventHandler(this.rbtL1_CheckedChanged);
			// 
			// rbtL2
			// 
			this.rbtL2.Location = new System.Drawing.Point(504, 8);
			this.rbtL2.Name = "rbtL2";
			this.rbtL2.Size = new System.Drawing.Size(64, 24);
			this.rbtL2.TabIndex = 31;
			this.rbtL2.Text = "Loan &2";
			this.rbtL2.CheckedChanged += new System.EventHandler(this.rbtL2_CheckedChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(248, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "&Number of payments 6 - 480 months:";
			// 
			// scrlAmount
			// 
			this.scrlAmount.Location = new System.Drawing.Point(8, 64);
			this.scrlAmount.Name = "scrlAmount";
			this.scrlAmount.Size = new System.Drawing.Size(368, 16);
			this.scrlAmount.TabIndex = 3;
			this.scrlAmount.TabStop = true;
			this.scrlAmount.Scroll += new System.Windows.Forms.ScrollEventHandler(this.scrlAmount_Scroll);
			// 
			// scrlMonths
			// 
			this.scrlMonths.LargeChange = 12;
			this.scrlMonths.Location = new System.Drawing.Point(8, 112);
			this.scrlMonths.Maximum = 480;
			this.scrlMonths.Minimum = 6;
			this.scrlMonths.Name = "scrlMonths";
			this.scrlMonths.Size = new System.Drawing.Size(368, 16);
			this.scrlMonths.SmallChange = 6;
			this.scrlMonths.TabIndex = 6;
			this.scrlMonths.TabStop = true;
			this.scrlMonths.Value = 6;
			this.scrlMonths.Scroll += new System.Windows.Forms.ScrollEventHandler(this.scrlMonths_Scroll);
			// 
			// cmbMonths
			// 
			this.cmbMonths.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbMonths.Items.AddRange(new object[] {
														   "custom",
														   "12  (1yr)",
														   "24  (2yrs)",
														   "36  (3yrs)",
														   "48  (4yrs)",
														   "60  (5yrs)",
														   "72  (6yrs)",
														   "120  (10yrs)",
														   "180  (15yrs)",
														   "240  (20yrs)",
														   "360  (30yrs)",
														   "480 (40yrs)"});
			this.cmbMonths.Location = new System.Drawing.Point(256, 91);
			this.cmbMonths.MaxDropDownItems = 12;
			this.cmbMonths.Name = "cmbMonths";
			this.cmbMonths.Size = new System.Drawing.Size(121, 21);
			this.cmbMonths.TabIndex = 5;
			this.cmbMonths.SelectedIndexChanged += new System.EventHandler(this.cmbMonths_SelectedIndexChanged);
			// 
			// cmbInterest
			// 
			this.cmbInterest.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbInterest.Items.AddRange(new object[] {
															 "custom",
															 "0.0%",
															 "0.9%",
															 "1.9%",
															 "2.9%",
															 "3.0%",
															 "3.25%",
															 "3.50%",
															 "3.75%",
															 "4.00%",
															 "4.25%",
															 "4.50%",
															 "4.75%",
															 "5.00%",
															 "5.25%",
															 "5.50%",
															 "5.75%",
															 "6.00%",
															 "6.25%",
															 "6.50%",
															 "6.75%",
															 "7.00%",
															 "7.25%",
															 "7.50%",
															 "7.75%",
															 "8.00%",
															 "8.25%",
															 "8.50%",
															 "8.75%",
															 "9.00%"});
			this.cmbInterest.Location = new System.Drawing.Point(256, 139);
			this.cmbInterest.MaxDropDownItems = 30;
			this.cmbInterest.Name = "cmbInterest";
			this.cmbInterest.Size = new System.Drawing.Size(121, 21);
			this.cmbInterest.TabIndex = 8;
			this.cmbInterest.SelectedIndexChanged += new System.EventHandler(this.cmbInterest_SelectedIndexChanged);
			// 
			// scrlInterest
			// 
			this.scrlInterest.Location = new System.Drawing.Point(8, 160);
			this.scrlInterest.Maximum = 193;
			this.scrlInterest.Name = "scrlInterest";
			this.scrlInterest.Size = new System.Drawing.Size(368, 16);
			this.scrlInterest.TabIndex = 9;
			this.scrlInterest.TabStop = true;
			this.scrlInterest.Scroll += new System.Windows.Forms.ScrollEventHandler(this.scrlInterest_Scroll);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 144);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(248, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "&Interest rate 0.0% - 24%:";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(208, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "Loan parameters";
			// 
			// groupBox3
			// 
			this.groupBox3.Location = new System.Drawing.Point(8, 32);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(368, 3);
			this.groupBox3.TabIndex = 1;
			this.groupBox3.TabStop = false;
			// 
			// gbAP1
			// 
			this.gbAP1.Location = new System.Drawing.Point(8, 264);
			this.gbAP1.Name = "gbAP1";
			this.gbAP1.Size = new System.Drawing.Size(368, 3);
			this.gbAP1.TabIndex = 13;
			this.gbAP1.TabStop = false;
			// 
			// dtpAP1
			// 
			this.dtpAP1.Location = new System.Drawing.Point(176, 288);
			this.dtpAP1.Name = "dtpAP1";
			this.dtpAP1.TabIndex = 15;
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 192);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(160, 20);
			this.label9.TabIndex = 10;
			this.label9.Text = "Loan &start date:";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// dtpStart
			// 
			this.dtpStart.Location = new System.Drawing.Point(176, 192);
			this.dtpStart.Name = "dtpStart";
			this.dtpStart.TabIndex = 11;
			this.dtpStart.ValueChanged += new System.EventHandler(this.dtpStart_ValueChanged);
			// 
			// dtpAP2
			// 
			this.dtpAP2.Location = new System.Drawing.Point(176, 320);
			this.dtpAP2.Name = "dtpAP2";
			this.dtpAP2.TabIndex = 17;
			// 
			// dtpAP3
			// 
			this.dtpAP3.Location = new System.Drawing.Point(176, 352);
			this.dtpAP3.Name = "dtpAP3";
			this.dtpAP3.TabIndex = 19;
			// 
			// lblAP1
			// 
			this.lblAP1.Location = new System.Drawing.Point(8, 288);
			this.lblAP1.Name = "lblAP1";
			this.lblAP1.Size = new System.Drawing.Size(160, 20);
			this.lblAP1.TabIndex = 14;
			this.lblAP1.Text = "&one-time payment made on:";
			this.lblAP1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblAP2
			// 
			this.lblAP2.Location = new System.Drawing.Point(8, 320);
			this.lblAP2.Name = "lblAP2";
			this.lblAP2.Size = new System.Drawing.Size(160, 20);
			this.lblAP2.TabIndex = 16;
			this.lblAP2.Text = "&yearly, starting on:";
			this.lblAP2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblAP3
			// 
			this.lblAP3.Location = new System.Drawing.Point(8, 352);
			this.lblAP3.Name = "lblAP3";
			this.lblAP3.Size = new System.Drawing.Size(160, 20);
			this.lblAP3.TabIndex = 18;
			this.lblAP3.Text = "&monthly, starting on:";
			this.lblAP3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// gbOG1
			// 
			this.gbOG1.Location = new System.Drawing.Point(8, 424);
			this.gbOG1.Name = "gbOG1";
			this.gbOG1.Size = new System.Drawing.Size(368, 3);
			this.gbOG1.TabIndex = 21;
			this.gbOG1.TabStop = false;
			// 
			// lblOG0
			// 
			this.lblOG0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblOG0.Location = new System.Drawing.Point(8, 408);
			this.lblOG0.Name = "lblOG0";
			this.lblOG0.Size = new System.Drawing.Size(368, 16);
			this.lblOG0.TabIndex = 20;
			this.lblOG0.Text = "Output Generated";
			// 
			// ckbOG4
			// 
			this.ckbOG4.Checked = true;
			this.ckbOG4.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOG4.Location = new System.Drawing.Point(192, 464);
			this.ckbOG4.Name = "ckbOG4";
			this.ckbOG4.Size = new System.Drawing.Size(168, 24);
			this.ckbOG4.TabIndex = 25;
			this.ckbOG4.Text = "Payment &graph";
			this.ckbOG4.CheckedChanged += new System.EventHandler(this.ckbOG4_CheckedChanged);
			// 
			// ckbOG2
			// 
			this.ckbOG2.Checked = true;
			this.ckbOG2.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOG2.Location = new System.Drawing.Point(8, 464);
			this.ckbOG2.Name = "ckbOG2";
			this.ckbOG2.Size = new System.Drawing.Size(168, 24);
			this.ckbOG2.TabIndex = 23;
			this.ckbOG2.Text = "Amortization &table";
			this.ckbOG2.CheckedChanged += new System.EventHandler(this.ckbOG2_CheckedChanged);
			// 
			// ckbOG3
			// 
			this.ckbOG3.Checked = true;
			this.ckbOG3.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOG3.Location = new System.Drawing.Point(192, 440);
			this.ckbOG3.Name = "ckbOG3";
			this.ckbOG3.Size = new System.Drawing.Size(168, 24);
			this.ckbOG3.TabIndex = 24;
			this.ckbOG3.Text = "&Comparison information";
			this.ckbOG3.CheckedChanged += new System.EventHandler(this.ckbOG3_CheckedChanged);
			// 
			// ckbOG1
			// 
			this.ckbOG1.Checked = true;
			this.ckbOG1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOG1.Location = new System.Drawing.Point(8, 440);
			this.ckbOG1.Name = "ckbOG1";
			this.ckbOG1.Size = new System.Drawing.Size(168, 24);
			this.ckbOG1.TabIndex = 22;
			this.ckbOG1.Text = "&Basic loan information";
			this.ckbOG1.CheckedChanged += new System.EventHandler(this.ckbOG1_CheckedChanged);
			// 
			// rbtL3
			// 
			this.rbtL3.Location = new System.Drawing.Point(608, 8);
			this.rbtL3.Name = "rbtL3";
			this.rbtL3.Size = new System.Drawing.Size(64, 24);
			this.rbtL3.TabIndex = 33;
			this.rbtL3.Text = "Loan &3";
			this.rbtL3.CheckedChanged += new System.EventHandler(this.rbtL3_CheckedChanged);
			// 
			// rbtL4
			// 
			this.rbtL4.Location = new System.Drawing.Point(712, 8);
			this.rbtL4.Name = "rbtL4";
			this.rbtL4.Size = new System.Drawing.Size(64, 24);
			this.rbtL4.TabIndex = 35;
			this.rbtL4.Text = "Loan &4";
			this.rbtL4.CheckedChanged += new System.EventHandler(this.rbtL4_CheckedChanged);
			// 
			// cmbNumLoans
			// 
			this.cmbNumLoans.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbNumLoans.Items.AddRange(new object[] {
															 "1",
															 "2",
															 "3",
															 "4"});
			this.cmbNumLoans.Location = new System.Drawing.Point(322, 8);
			this.cmbNumLoans.MaxDropDownItems = 5;
			this.cmbNumLoans.Name = "cmbNumLoans";
			this.cmbNumLoans.Size = new System.Drawing.Size(40, 21);
			this.cmbNumLoans.TabIndex = 27;
			this.cmbNumLoans.SelectedIndexChanged += new System.EventHandler(this.cmbNumLoans_SelectedIndexChanged);
			// 
			// label31
			// 
			this.label31.Location = new System.Drawing.Point(216, 8);
			this.label31.Name = "label31";
			this.label31.Size = new System.Drawing.Size(100, 21);
			this.label31.TabIndex = 26;
			this.label31.Text = "Number of &Loans:";
			this.label31.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ckbAP1
			// 
			this.ckbAP1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ckbAP1.Location = new System.Drawing.Point(8, 244);
			this.ckbAP1.Name = "ckbAP1";
			this.ckbAP1.Size = new System.Drawing.Size(272, 20);
			this.ckbAP1.TabIndex = 12;
			this.ckbAP1.Text = "Additional &Principal Payment(s)";
			this.ckbAP1.CheckedChanged += new System.EventHandler(this.ckbAP1_CheckedChanged);
			// 
			// pnlL1
			// 
			this.pnlL1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlL1.Controls.Add(this.spnAmtL1);
			this.pnlL1.Controls.Add(this.spnMthsL1);
			this.pnlL1.Controls.Add(this.lblL1AP3);
			this.pnlL1.Controls.Add(this.lblL1AP2);
			this.pnlL1.Controls.Add(this.lblL1AP1);
			this.pnlL1.Controls.Add(this.edtL1AP3);
			this.pnlL1.Controls.Add(this.edtL1AP2);
			this.pnlL1.Controls.Add(this.edtL1AP1);
			this.pnlL1.Controls.Add(this.lblLastL1);
			this.pnlL1.Controls.Add(this.label5);
			this.pnlL1.Controls.Add(this.txtPayL1);
			this.pnlL1.Controls.Add(this.spnIntL1);
			this.pnlL1.Location = new System.Drawing.Point(384, 36);
			this.pnlL1.Name = "pnlL1";
			this.pnlL1.Size = new System.Drawing.Size(96, 460);
			this.pnlL1.TabIndex = 30;
			// 
			// spnAmtL1
			// 
			this.spnAmtL1.Increment = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.spnAmtL1.Location = new System.Drawing.Point(7, 11);
			this.spnAmtL1.Maximum = new System.Decimal(new int[] {
																	 100000000,
																	 0,
																	 0,
																	 0});
			this.spnAmtL1.Name = "spnAmtL1";
			this.spnAmtL1.Size = new System.Drawing.Size(80, 20);
			this.spnAmtL1.TabIndex = 0;
			this.spnAmtL1.ThousandsSeparator = true;
			this.spnAmtL1.ValueChanged += new System.EventHandler(this.spnAmtL1_ValueChanged);
			// 
			// spnMthsL1
			// 
			this.spnMthsL1.Increment = new System.Decimal(new int[] {
																		6,
																		0,
																		0,
																		0});
			this.spnMthsL1.Location = new System.Drawing.Point(7, 59);
			this.spnMthsL1.Maximum = new System.Decimal(new int[] {
																	  480,
																	  0,
																	  0,
																	  0});
			this.spnMthsL1.Minimum = new System.Decimal(new int[] {
																	  6,
																	  0,
																	  0,
																	  0});
			this.spnMthsL1.Name = "spnMthsL1";
			this.spnMthsL1.Size = new System.Drawing.Size(80, 20);
			this.spnMthsL1.TabIndex = 1;
			this.spnMthsL1.Value = new System.Decimal(new int[] {
																	6,
																	0,
																	0,
																	0});
			this.spnMthsL1.ValueChanged += new System.EventHandler(this.spnMthsL1_ValueChanged);
			// 
			// lblL1AP3
			// 
			this.lblL1AP3.Location = new System.Drawing.Point(7, 411);
			this.lblL1AP3.Name = "lblL1AP3";
			this.lblL1AP3.Size = new System.Drawing.Size(80, 40);
			this.lblL1AP3.TabIndex = 11;
			this.lblL1AP3.Text = "Loan length decreased by 99 months.";
			// 
			// lblL1AP2
			// 
			this.lblL1AP2.Location = new System.Drawing.Point(7, 379);
			this.lblL1AP2.Name = "lblL1AP2";
			this.lblL1AP2.Size = new System.Drawing.Size(80, 32);
			this.lblL1AP2.TabIndex = 10;
			this.lblL1AP2.Text = "Savings:  $12,345.67";
			// 
			// lblL1AP1
			// 
			this.lblL1AP1.Location = new System.Drawing.Point(7, 347);
			this.lblL1AP1.Name = "lblL1AP1";
			this.lblL1AP1.Size = new System.Drawing.Size(80, 32);
			this.lblL1AP1.TabIndex = 9;
			this.lblL1AP1.Text = "Last payment:  99/99/2999";
			// 
			// edtL1AP3
			// 
			this.edtL1AP3.Location = new System.Drawing.Point(7, 315);
			this.edtL1AP3.Name = "edtL1AP3";
			this.edtL1AP3.Size = new System.Drawing.Size(80, 20);
			this.edtL1AP3.TabIndex = 8;
			this.edtL1AP3.Text = "";
			// 
			// edtL1AP2
			// 
			this.edtL1AP2.Location = new System.Drawing.Point(7, 283);
			this.edtL1AP2.Name = "edtL1AP2";
			this.edtL1AP2.Size = new System.Drawing.Size(80, 20);
			this.edtL1AP2.TabIndex = 7;
			this.edtL1AP2.Text = "";
			// 
			// edtL1AP1
			// 
			this.edtL1AP1.Location = new System.Drawing.Point(7, 251);
			this.edtL1AP1.Name = "edtL1AP1";
			this.edtL1AP1.Size = new System.Drawing.Size(80, 20);
			this.edtL1AP1.TabIndex = 6;
			this.edtL1AP1.Text = "";
			// 
			// lblLastL1
			// 
			this.lblLastL1.Location = new System.Drawing.Point(7, 195);
			this.lblLastL1.Name = "lblLastL1";
			this.lblLastL1.Size = new System.Drawing.Size(80, 28);
			this.lblLastL1.TabIndex = 5;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(7, 147);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(80, 16);
			this.label5.TabIndex = 3;
			this.label5.Text = "Payment:";
			// 
			// txtPayL1
			// 
			this.txtPayL1.Location = new System.Drawing.Point(7, 163);
			this.txtPayL1.Name = "txtPayL1";
			this.txtPayL1.Size = new System.Drawing.Size(80, 20);
			this.txtPayL1.TabIndex = 4;
			this.txtPayL1.Text = "";
			// 
			// spnIntL1
			// 
			this.spnIntL1.DecimalPlaces = 3;
			this.spnIntL1.Increment = new System.Decimal(new int[] {
																	   125,
																	   0,
																	   0,
																	   196608});
			this.spnIntL1.Location = new System.Drawing.Point(7, 107);
			this.spnIntL1.Maximum = new System.Decimal(new int[] {
																	 24,
																	 0,
																	 0,
																	 0});
			this.spnIntL1.Name = "spnIntL1";
			this.spnIntL1.Size = new System.Drawing.Size(80, 20);
			this.spnIntL1.TabIndex = 2;
			this.spnIntL1.Value = new System.Decimal(new int[] {
																   6,
																   0,
																   0,
																   0});
			this.spnIntL1.ValueChanged += new System.EventHandler(this.spnIntL1_ValueChanged);
			// 
			// pnlL2
			// 
			this.pnlL2.Controls.Add(this.spnAmtL2);
			this.pnlL2.Controls.Add(this.spnMthsL2);
			this.pnlL2.Controls.Add(this.lblL2AP3);
			this.pnlL2.Controls.Add(this.lblL2AP2);
			this.pnlL2.Controls.Add(this.lblL2AP1);
			this.pnlL2.Controls.Add(this.edtL2AP3);
			this.pnlL2.Controls.Add(this.edtL2AP2);
			this.pnlL2.Controls.Add(this.edtL2AP1);
			this.pnlL2.Controls.Add(this.lblLastL2);
			this.pnlL2.Controls.Add(this.label6);
			this.pnlL2.Controls.Add(this.txtPayL2);
			this.pnlL2.Controls.Add(this.spnIntL2);
			this.pnlL2.Location = new System.Drawing.Point(488, 36);
			this.pnlL2.Name = "pnlL2";
			this.pnlL2.Size = new System.Drawing.Size(96, 460);
			this.pnlL2.TabIndex = 32;
			// 
			// spnAmtL2
			// 
			this.spnAmtL2.Increment = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.spnAmtL2.Location = new System.Drawing.Point(8, 10);
			this.spnAmtL2.Maximum = new System.Decimal(new int[] {
																	 100000000,
																	 0,
																	 0,
																	 0});
			this.spnAmtL2.Name = "spnAmtL2";
			this.spnAmtL2.Size = new System.Drawing.Size(80, 20);
			this.spnAmtL2.TabIndex = 0;
			this.spnAmtL2.ThousandsSeparator = true;
			this.spnAmtL2.ValueChanged += new System.EventHandler(this.spnAmtL2_ValueChanged);
			// 
			// spnMthsL2
			// 
			this.spnMthsL2.Increment = new System.Decimal(new int[] {
																		6,
																		0,
																		0,
																		0});
			this.spnMthsL2.Location = new System.Drawing.Point(8, 58);
			this.spnMthsL2.Maximum = new System.Decimal(new int[] {
																	  480,
																	  0,
																	  0,
																	  0});
			this.spnMthsL2.Minimum = new System.Decimal(new int[] {
																	  6,
																	  0,
																	  0,
																	  0});
			this.spnMthsL2.Name = "spnMthsL2";
			this.spnMthsL2.Size = new System.Drawing.Size(80, 20);
			this.spnMthsL2.TabIndex = 1;
			this.spnMthsL2.Value = new System.Decimal(new int[] {
																	6,
																	0,
																	0,
																	0});
			this.spnMthsL2.ValueChanged += new System.EventHandler(this.spnMthsL2_ValueChanged);
			// 
			// lblL2AP3
			// 
			this.lblL2AP3.Location = new System.Drawing.Point(8, 410);
			this.lblL2AP3.Name = "lblL2AP3";
			this.lblL2AP3.Size = new System.Drawing.Size(80, 40);
			this.lblL2AP3.TabIndex = 11;
			this.lblL2AP3.Text = "Loan length decreased by 99 months.";
			// 
			// lblL2AP2
			// 
			this.lblL2AP2.Location = new System.Drawing.Point(8, 378);
			this.lblL2AP2.Name = "lblL2AP2";
			this.lblL2AP2.Size = new System.Drawing.Size(80, 32);
			this.lblL2AP2.TabIndex = 10;
			this.lblL2AP2.Text = "Savings:  $12,345.67";
			// 
			// lblL2AP1
			// 
			this.lblL2AP1.Location = new System.Drawing.Point(8, 346);
			this.lblL2AP1.Name = "lblL2AP1";
			this.lblL2AP1.Size = new System.Drawing.Size(80, 32);
			this.lblL2AP1.TabIndex = 9;
			this.lblL2AP1.Text = "Last payment:  99/99/2999";
			// 
			// edtL2AP3
			// 
			this.edtL2AP3.Location = new System.Drawing.Point(8, 314);
			this.edtL2AP3.Name = "edtL2AP3";
			this.edtL2AP3.Size = new System.Drawing.Size(80, 20);
			this.edtL2AP3.TabIndex = 8;
			this.edtL2AP3.Text = "";
			// 
			// edtL2AP2
			// 
			this.edtL2AP2.Location = new System.Drawing.Point(8, 282);
			this.edtL2AP2.Name = "edtL2AP2";
			this.edtL2AP2.Size = new System.Drawing.Size(80, 20);
			this.edtL2AP2.TabIndex = 7;
			this.edtL2AP2.Text = "";
			// 
			// edtL2AP1
			// 
			this.edtL2AP1.Location = new System.Drawing.Point(8, 250);
			this.edtL2AP1.Name = "edtL2AP1";
			this.edtL2AP1.Size = new System.Drawing.Size(80, 20);
			this.edtL2AP1.TabIndex = 6;
			this.edtL2AP1.Text = "";
			// 
			// lblLastL2
			// 
			this.lblLastL2.Location = new System.Drawing.Point(8, 194);
			this.lblLastL2.Name = "lblLastL2";
			this.lblLastL2.Size = new System.Drawing.Size(80, 28);
			this.lblLastL2.TabIndex = 5;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 146);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(80, 16);
			this.label6.TabIndex = 3;
			this.label6.Text = "Payment:";
			// 
			// txtPayL2
			// 
			this.txtPayL2.Location = new System.Drawing.Point(8, 162);
			this.txtPayL2.Name = "txtPayL2";
			this.txtPayL2.Size = new System.Drawing.Size(80, 20);
			this.txtPayL2.TabIndex = 4;
			this.txtPayL2.Text = "";
			// 
			// spnIntL2
			// 
			this.spnIntL2.DecimalPlaces = 3;
			this.spnIntL2.Increment = new System.Decimal(new int[] {
																	   125,
																	   0,
																	   0,
																	   196608});
			this.spnIntL2.Location = new System.Drawing.Point(8, 106);
			this.spnIntL2.Maximum = new System.Decimal(new int[] {
																	 24,
																	 0,
																	 0,
																	 0});
			this.spnIntL2.Name = "spnIntL2";
			this.spnIntL2.Size = new System.Drawing.Size(80, 20);
			this.spnIntL2.TabIndex = 2;
			this.spnIntL2.Value = new System.Decimal(new int[] {
																   6,
																   0,
																   0,
																   0});
			this.spnIntL2.ValueChanged += new System.EventHandler(this.spnIntL2_ValueChanged);
			// 
			// pnlL3
			// 
			this.pnlL3.Controls.Add(this.spnAmtL3);
			this.pnlL3.Controls.Add(this.spnMthsL3);
			this.pnlL3.Controls.Add(this.lblL3AP3);
			this.pnlL3.Controls.Add(this.lblL3AP2);
			this.pnlL3.Controls.Add(this.lblL3AP1);
			this.pnlL3.Controls.Add(this.edtL3AP3);
			this.pnlL3.Controls.Add(this.edtL3AP2);
			this.pnlL3.Controls.Add(this.edtL3AP1);
			this.pnlL3.Controls.Add(this.lblLastL3);
			this.pnlL3.Controls.Add(this.label25);
			this.pnlL3.Controls.Add(this.txtPayL3);
			this.pnlL3.Controls.Add(this.spnIntL3);
			this.pnlL3.Location = new System.Drawing.Point(592, 36);
			this.pnlL3.Name = "pnlL3";
			this.pnlL3.Size = new System.Drawing.Size(96, 460);
			this.pnlL3.TabIndex = 34;
			// 
			// spnAmtL3
			// 
			this.spnAmtL3.Increment = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.spnAmtL3.Location = new System.Drawing.Point(8, 10);
			this.spnAmtL3.Maximum = new System.Decimal(new int[] {
																	 100000000,
																	 0,
																	 0,
																	 0});
			this.spnAmtL3.Name = "spnAmtL3";
			this.spnAmtL3.Size = new System.Drawing.Size(80, 20);
			this.spnAmtL3.TabIndex = 0;
			this.spnAmtL3.ThousandsSeparator = true;
			this.spnAmtL3.ValueChanged += new System.EventHandler(this.spnAmtL3_ValueChanged);
			// 
			// spnMthsL3
			// 
			this.spnMthsL3.Increment = new System.Decimal(new int[] {
																		6,
																		0,
																		0,
																		0});
			this.spnMthsL3.Location = new System.Drawing.Point(8, 58);
			this.spnMthsL3.Maximum = new System.Decimal(new int[] {
																	  480,
																	  0,
																	  0,
																	  0});
			this.spnMthsL3.Minimum = new System.Decimal(new int[] {
																	  6,
																	  0,
																	  0,
																	  0});
			this.spnMthsL3.Name = "spnMthsL3";
			this.spnMthsL3.Size = new System.Drawing.Size(80, 20);
			this.spnMthsL3.TabIndex = 1;
			this.spnMthsL3.Value = new System.Decimal(new int[] {
																	6,
																	0,
																	0,
																	0});
			this.spnMthsL3.ValueChanged += new System.EventHandler(this.spnMthsL3_ValueChanged);
			// 
			// lblL3AP3
			// 
			this.lblL3AP3.Location = new System.Drawing.Point(8, 410);
			this.lblL3AP3.Name = "lblL3AP3";
			this.lblL3AP3.Size = new System.Drawing.Size(80, 40);
			this.lblL3AP3.TabIndex = 11;
			this.lblL3AP3.Text = "Loan length decreased by 99 months.";
			// 
			// lblL3AP2
			// 
			this.lblL3AP2.Location = new System.Drawing.Point(8, 378);
			this.lblL3AP2.Name = "lblL3AP2";
			this.lblL3AP2.Size = new System.Drawing.Size(80, 32);
			this.lblL3AP2.TabIndex = 10;
			this.lblL3AP2.Text = "Savings:  $12,345.67";
			// 
			// lblL3AP1
			// 
			this.lblL3AP1.Location = new System.Drawing.Point(8, 346);
			this.lblL3AP1.Name = "lblL3AP1";
			this.lblL3AP1.Size = new System.Drawing.Size(80, 32);
			this.lblL3AP1.TabIndex = 9;
			this.lblL3AP1.Text = "Last payment:  99/99/2999";
			// 
			// edtL3AP3
			// 
			this.edtL3AP3.Location = new System.Drawing.Point(8, 314);
			this.edtL3AP3.Name = "edtL3AP3";
			this.edtL3AP3.Size = new System.Drawing.Size(80, 20);
			this.edtL3AP3.TabIndex = 8;
			this.edtL3AP3.Text = "";
			// 
			// edtL3AP2
			// 
			this.edtL3AP2.Location = new System.Drawing.Point(8, 282);
			this.edtL3AP2.Name = "edtL3AP2";
			this.edtL3AP2.Size = new System.Drawing.Size(80, 20);
			this.edtL3AP2.TabIndex = 7;
			this.edtL3AP2.Text = "";
			// 
			// edtL3AP1
			// 
			this.edtL3AP1.Location = new System.Drawing.Point(8, 250);
			this.edtL3AP1.Name = "edtL3AP1";
			this.edtL3AP1.Size = new System.Drawing.Size(80, 20);
			this.edtL3AP1.TabIndex = 6;
			this.edtL3AP1.Text = "";
			// 
			// lblLastL3
			// 
			this.lblLastL3.Location = new System.Drawing.Point(8, 194);
			this.lblLastL3.Name = "lblLastL3";
			this.lblLastL3.Size = new System.Drawing.Size(80, 28);
			this.lblLastL3.TabIndex = 5;
			// 
			// label25
			// 
			this.label25.Location = new System.Drawing.Point(8, 146);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(80, 16);
			this.label25.TabIndex = 3;
			this.label25.Text = "Payment:";
			// 
			// txtPayL3
			// 
			this.txtPayL3.Location = new System.Drawing.Point(8, 162);
			this.txtPayL3.Name = "txtPayL3";
			this.txtPayL3.Size = new System.Drawing.Size(80, 20);
			this.txtPayL3.TabIndex = 4;
			this.txtPayL3.Text = "";
			// 
			// spnIntL3
			// 
			this.spnIntL3.DecimalPlaces = 3;
			this.spnIntL3.Increment = new System.Decimal(new int[] {
																	   125,
																	   0,
																	   0,
																	   196608});
			this.spnIntL3.Location = new System.Drawing.Point(8, 106);
			this.spnIntL3.Maximum = new System.Decimal(new int[] {
																	 24,
																	 0,
																	 0,
																	 0});
			this.spnIntL3.Name = "spnIntL3";
			this.spnIntL3.Size = new System.Drawing.Size(80, 20);
			this.spnIntL3.TabIndex = 2;
			this.spnIntL3.Value = new System.Decimal(new int[] {
																   6,
																   0,
																   0,
																   0});
			this.spnIntL3.ValueChanged += new System.EventHandler(this.spnIntL3_ValueChanged);
			// 
			// pnlL4
			// 
			this.pnlL4.Controls.Add(this.spnAmtL4);
			this.pnlL4.Controls.Add(this.spnMthsL4);
			this.pnlL4.Controls.Add(this.lblL4AP3);
			this.pnlL4.Controls.Add(this.lblL4AP2);
			this.pnlL4.Controls.Add(this.lblL4AP1);
			this.pnlL4.Controls.Add(this.edtL4AP3);
			this.pnlL4.Controls.Add(this.edtL4AP2);
			this.pnlL4.Controls.Add(this.edtL4AP1);
			this.pnlL4.Controls.Add(this.lblLastL4);
			this.pnlL4.Controls.Add(this.label30);
			this.pnlL4.Controls.Add(this.txtPayL4);
			this.pnlL4.Controls.Add(this.spnIntL4);
			this.pnlL4.Location = new System.Drawing.Point(696, 36);
			this.pnlL4.Name = "pnlL4";
			this.pnlL4.Size = new System.Drawing.Size(96, 460);
			this.pnlL4.TabIndex = 36;
			// 
			// spnAmtL4
			// 
			this.spnAmtL4.Increment = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.spnAmtL4.Location = new System.Drawing.Point(8, 10);
			this.spnAmtL4.Maximum = new System.Decimal(new int[] {
																	 100000000,
																	 0,
																	 0,
																	 0});
			this.spnAmtL4.Name = "spnAmtL4";
			this.spnAmtL4.Size = new System.Drawing.Size(80, 20);
			this.spnAmtL4.TabIndex = 0;
			this.spnAmtL4.ThousandsSeparator = true;
			this.spnAmtL4.ValueChanged += new System.EventHandler(this.spnAmtL4_ValueChanged);
			// 
			// spnMthsL4
			// 
			this.spnMthsL4.Increment = new System.Decimal(new int[] {
																		6,
																		0,
																		0,
																		0});
			this.spnMthsL4.Location = new System.Drawing.Point(8, 58);
			this.spnMthsL4.Maximum = new System.Decimal(new int[] {
																	  480,
																	  0,
																	  0,
																	  0});
			this.spnMthsL4.Minimum = new System.Decimal(new int[] {
																	  6,
																	  0,
																	  0,
																	  0});
			this.spnMthsL4.Name = "spnMthsL4";
			this.spnMthsL4.Size = new System.Drawing.Size(80, 20);
			this.spnMthsL4.TabIndex = 1;
			this.spnMthsL4.Value = new System.Decimal(new int[] {
																	6,
																	0,
																	0,
																	0});
			this.spnMthsL4.ValueChanged += new System.EventHandler(this.spnMthsL4_ValueChanged);
			// 
			// lblL4AP3
			// 
			this.lblL4AP3.Location = new System.Drawing.Point(8, 410);
			this.lblL4AP3.Name = "lblL4AP3";
			this.lblL4AP3.Size = new System.Drawing.Size(80, 40);
			this.lblL4AP3.TabIndex = 11;
			this.lblL4AP3.Text = "Loan length decreased by 99 months.";
			// 
			// lblL4AP2
			// 
			this.lblL4AP2.Location = new System.Drawing.Point(8, 378);
			this.lblL4AP2.Name = "lblL4AP2";
			this.lblL4AP2.Size = new System.Drawing.Size(80, 32);
			this.lblL4AP2.TabIndex = 10;
			this.lblL4AP2.Text = "Savings:  $12,345.67";
			// 
			// lblL4AP1
			// 
			this.lblL4AP1.Location = new System.Drawing.Point(8, 346);
			this.lblL4AP1.Name = "lblL4AP1";
			this.lblL4AP1.Size = new System.Drawing.Size(80, 32);
			this.lblL4AP1.TabIndex = 9;
			this.lblL4AP1.Text = "Last payment:  99/99/2999";
			// 
			// edtL4AP3
			// 
			this.edtL4AP3.Location = new System.Drawing.Point(8, 314);
			this.edtL4AP3.Name = "edtL4AP3";
			this.edtL4AP3.Size = new System.Drawing.Size(80, 20);
			this.edtL4AP3.TabIndex = 8;
			this.edtL4AP3.Text = "";
			// 
			// edtL4AP2
			// 
			this.edtL4AP2.Location = new System.Drawing.Point(8, 282);
			this.edtL4AP2.Name = "edtL4AP2";
			this.edtL4AP2.Size = new System.Drawing.Size(80, 20);
			this.edtL4AP2.TabIndex = 7;
			this.edtL4AP2.Text = "";
			// 
			// edtL4AP1
			// 
			this.edtL4AP1.Location = new System.Drawing.Point(8, 250);
			this.edtL4AP1.Name = "edtL4AP1";
			this.edtL4AP1.Size = new System.Drawing.Size(80, 20);
			this.edtL4AP1.TabIndex = 6;
			this.edtL4AP1.Text = "";
			// 
			// lblLastL4
			// 
			this.lblLastL4.Location = new System.Drawing.Point(8, 194);
			this.lblLastL4.Name = "lblLastL4";
			this.lblLastL4.Size = new System.Drawing.Size(80, 28);
			this.lblLastL4.TabIndex = 5;
			// 
			// label30
			// 
			this.label30.Location = new System.Drawing.Point(8, 146);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(80, 16);
			this.label30.TabIndex = 3;
			this.label30.Text = "Payment:";
			// 
			// txtPayL4
			// 
			this.txtPayL4.Location = new System.Drawing.Point(8, 162);
			this.txtPayL4.Name = "txtPayL4";
			this.txtPayL4.Size = new System.Drawing.Size(80, 20);
			this.txtPayL4.TabIndex = 4;
			this.txtPayL4.Text = "";
			// 
			// spnIntL4
			// 
			this.spnIntL4.DecimalPlaces = 3;
			this.spnIntL4.Increment = new System.Decimal(new int[] {
																	   125,
																	   0,
																	   0,
																	   196608});
			this.spnIntL4.Location = new System.Drawing.Point(8, 106);
			this.spnIntL4.Maximum = new System.Decimal(new int[] {
																	 24,
																	 0,
																	 0,
																	 0});
			this.spnIntL4.Name = "spnIntL4";
			this.spnIntL4.Size = new System.Drawing.Size(80, 20);
			this.spnIntL4.TabIndex = 2;
			this.spnIntL4.Value = new System.Decimal(new int[] {
																   6,
																   0,
																   0,
																   0});
			this.spnIntL4.ValueChanged += new System.EventHandler(this.spnIntL4_ValueChanged);
			// 
			// button1
			// 
			this.button1.Font = new System.Drawing.Font("Arial Black", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.Location = new System.Drawing.Point(362, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(14, 21);
			this.button1.TabIndex = 28;
			this.button1.Text = "";
			this.toolTip1.SetToolTip(this.button1, "Click with:  button 1 to add a loan, button 2 to subtract a loan.");
			this.button1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.button1_MouseDown);
			// 
			// toolTip1
			// 
			this.toolTip1.AutoPopDelay = 10000;
			this.toolTip1.InitialDelay = 500;
			this.toolTip1.ReshowDelay = 100;
			this.toolTip1.ShowAlways = true;
			// 
			// ckbCode
			// 
			this.ckbCode.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.ckbCode.Location = new System.Drawing.Point(8, 520);
			this.ckbCode.Name = "ckbCode";
			this.ckbCode.Size = new System.Drawing.Size(128, 24);
			this.ckbCode.TabIndex = 39;
			this.ckbCode.Text = "Preview &SAS code";
			this.ckbCode.CheckedChanged += new System.EventHandler(this.ckbCode_CheckedChanged);
			// 
			// LoanCompareForm
			// 
			this.AcceptButton = this.btnOK;
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(802, 546);
			this.Controls.Add(this.ckbCode);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.pnlL4);
			this.Controls.Add(this.pnlL3);
			this.Controls.Add(this.pnlL2);
			this.Controls.Add(this.pnlL1);
			this.Controls.Add(this.ckbAP1);
			this.Controls.Add(this.label31);
			this.Controls.Add(this.cmbNumLoans);
			this.Controls.Add(this.rbtL4);
			this.Controls.Add(this.rbtL3);
			this.Controls.Add(this.ckbOG3);
			this.Controls.Add(this.ckbOG1);
			this.Controls.Add(this.ckbOG4);
			this.Controls.Add(this.ckbOG2);
			this.Controls.Add(this.rbtL1);
			this.Controls.Add(this.gbOG1);
			this.Controls.Add(this.lblOG0);
			this.Controls.Add(this.lblAP3);
			this.Controls.Add(this.lblAP2);
			this.Controls.Add(this.lblAP1);
			this.Controls.Add(this.dtpAP3);
			this.Controls.Add(this.dtpAP2);
			this.Controls.Add(this.dtpStart);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.dtpAP1);
			this.Controls.Add(this.gbAP1);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.cmbInterest);
			this.Controls.Add(this.scrlInterest);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cmbMonths);
			this.Controls.Add(this.scrlMonths);
			this.Controls.Add(this.scrlAmount);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.rbtL2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "LoanCompareForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "SAS Custom Task";
			this.Load += new System.EventHandler(this.LoanCompareForm_Load);
			this.pnlL1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL1)).EndInit();
			this.pnlL2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL2)).EndInit();
			this.pnlL3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL3)).EndInit();
			this.pnlL4.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.spnAmtL4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnMthsL4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.spnIntL4)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void textBox2_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void textBox3_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void ckbAP1_CheckedChanged(object sender, System.EventArgs e)
		{
			bool	bFlag = ckbAP1.Checked;

			gbAP1.Visible = bFlag;
			lblAP1.Visible = lblAP2.Visible = lblAP3.Visible = bFlag;
			dtpAP1.Visible = dtpAP2.Visible = dtpAP3.Visible = bFlag;
			edtL1AP1.Visible = edtL1AP2.Visible = edtL1AP3.Visible = bFlag;
			edtL2AP1.Visible = edtL2AP2.Visible = edtL2AP3.Visible = bFlag;
			edtL3AP1.Visible = edtL3AP2.Visible = edtL3AP3.Visible = bFlag;
			edtL4AP1.Visible = edtL4AP2.Visible = edtL4AP3.Visible = bFlag;
			lblL1AP1.Visible = lblL1AP2.Visible = lblL1AP3.Visible = bFlag;
			lblL2AP1.Visible = lblL2AP2.Visible = lblL2AP3.Visible = bFlag;
			lblL3AP1.Visible = lblL3AP2.Visible = lblL3AP3.Visible = bFlag;
			lblL4AP1.Visible = lblL4AP2.Visible = lblL4AP3.Visible = bFlag;

			if ( bFlag )
			{
				pnlL1.Size = new Size(96,460);
				pnlL2.Size = new Size(96,460);
				pnlL3.Size = new Size(96,460);
				pnlL4.Size = new Size(96,460);

				Point	pntO;
				Size	sizO;
				int		iAmt=(14*8);
				pntO = lblOG0.Location;	pntO.Y += iAmt;			lblOG0.Location = pntO;
				pntO = gbOG1.Location;	pntO.Y += iAmt;			gbOG1.Location = pntO;
				pntO = ckbOG1.Location;	pntO.Y += iAmt;			ckbOG1.Location = pntO;
				pntO = ckbOG2.Location;	pntO.Y += iAmt;			ckbOG2.Location = pntO;
				pntO = ckbOG3.Location;	pntO.Y += iAmt;			ckbOG3.Location = pntO;
				pntO = ckbOG4.Location;	pntO.Y += iAmt;			ckbOG4.Location = pntO;

				sizO = this.Size;	sizO.Height += (iAmt + 16);		this.Size = sizO;
			}
			else
			{
				pnlL1.Size = new Size(96,236);
				pnlL2.Size = new Size(96,236);
				pnlL3.Size = new Size(96,236);
				pnlL4.Size = new Size(96,236);

				Point	pntO;
				Size	sizO;
				int		iAmt=(14*8);
				pntO = lblOG0.Location;	pntO.Y -= iAmt;			lblOG0.Location = pntO;
				pntO = gbOG1.Location;	pntO.Y -= iAmt;			gbOG1.Location = pntO;
				pntO = ckbOG1.Location;	pntO.Y -= iAmt;			ckbOG1.Location = pntO;
				pntO = ckbOG2.Location;	pntO.Y -= iAmt;			ckbOG2.Location = pntO;
				pntO = ckbOG3.Location;	pntO.Y -= iAmt;			ckbOG3.Location = pntO;
				pntO = ckbOG4.Location;	pntO.Y -= iAmt;			ckbOG4.Location = pntO;

				sizO = this.Size;	sizO.Height -= (iAmt + 16);		this.Size = sizO;
			}
		}

		private void cmbNumLoans_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// store the index in the model
			_taskModel.iNumLoans = cmbNumLoans.SelectedIndex;

			int	iNumLoans = Convert.ToInt32(cmbNumLoans.SelectedItem.ToString());

			Size	sizO;

			sizO = this.Size;

			// 808  702  598   494
			if ( iNumLoans == 4 )
				sizO.Width = 808;
			else
				sizO.Width = 494 + ((iNumLoans-1) * 104);

			this.Size = sizO;

			if ( iNumLoans < iLoanIndex )
			{
				iLoanIndex = iNumLoans;
				rbtL1.Checked = rbtL2.Checked = rbtL3.Checked = rbtL4.Checked = false;
				switch ( iLoanIndex )
				{
					case 1: rbtL1.Checked = true; break;
					case 2: rbtL2.Checked = true; break;
					case 3: rbtL3.Checked = true; break;
					case 4: rbtL4.Checked = true; break;
				}
			}
		}

		private void LoanCompareForm_Load(object sender, System.EventArgs e)
		{
			cmbNumLoans.SelectedIndex = 0;
			ckbAP1.Checked = false;
			ckbAP1_CheckedChanged(null, null);

			// load task state
			ckbOG1.Checked = _taskModel.bBasicInfo;
			ckbOG2.Checked = _taskModel.bAmortTable;
			ckbOG3.Checked = _taskModel.bCompare;
			ckbOG4.Checked = _taskModel.bPayGraph;

			cmbNumLoans.SelectedIndex = _taskModel.iNumLoans;

			// all loan info

			// prepayment info

			// points info

			// balloon info

			// adjustable rate info

			UpdateControls();
		}

		private void rbtL1_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( rbtL1.Checked )
			{
				iLoanIndex = 1;
				pnlL1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;

				scrlAmount.Value = ( spnAmtL1.Value < 1000000 ) ? (int)spnAmtL1.Value / 10000 : 100;
				scrlMonths.Value = (int)spnMthsL1.Value;
				scrlInterest.Value = (int)((double)spnIntL1.Value / 0.125);
			}
			else
				pnlL1.BorderStyle = System.Windows.Forms.BorderStyle.None;
		}

		private void rbtL2_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( rbtL2.Checked )
			{
				iLoanIndex = 2;
				pnlL2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;

				scrlAmount.Value = ( spnAmtL2.Value < 1000000 ) ? (int)spnAmtL2.Value / 10000 : 100;
				scrlMonths.Value = (int)spnMthsL2.Value;
				scrlInterest.Value = (int)((double)spnIntL2.Value / 0.125);
			}
			else
				pnlL2.BorderStyle = System.Windows.Forms.BorderStyle.None;
		}

		private void rbtL3_CheckedChanged(object sender, System.EventArgs e)
		{
			pnlL3.BorderStyle = rbtL3.Checked ? System.Windows.Forms.BorderStyle.FixedSingle : System.Windows.Forms.BorderStyle.None;
			iLoanIndex = rbtL3.Checked ? 3 : iLoanIndex;
		}

		private void rbtL4_CheckedChanged(object sender, System.EventArgs e)
		{
			pnlL4.BorderStyle = rbtL4.Checked ? System.Windows.Forms.BorderStyle.FixedSingle : System.Windows.Forms.BorderStyle.None;
			iLoanIndex = rbtL4.Checked ? 4 : iLoanIndex;
		}

		private void button1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( e.Button == System.Windows.Forms.MouseButtons.Left )
			{
				if ( cmbNumLoans.SelectedIndex < 3 )
					cmbNumLoans.SelectedIndex += 1;
				else
					user32.MessageBeep(-1);
			}
			else if ( e.Button == System.Windows.Forms.MouseButtons.Right )
			{
				if ( cmbNumLoans.SelectedIndex > 0 )
					cmbNumLoans.SelectedIndex -= 1;
				else
					user32.MessageBeep(-1);
			}
		}

		private void scrlAmount_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			int iAmt = scrlAmount.Value * 10000;
			switch ( iLoanIndex )
			{
				case 1: spnAmtL1.Value = iAmt; break;
				case 2: spnAmtL2.Value = iAmt; break;
				case 3: spnAmtL3.Value = iAmt; break;
				case 4: spnAmtL4.Value = iAmt; break;
			}

			UpdateControls();
		}

		private void scrlMonths_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			switch ( iLoanIndex )
			{
				case 1: spnMthsL1.Value = scrlMonths.Value; break;
				case 2: spnMthsL2.Value = scrlMonths.Value; break;
				case 3: spnMthsL3.Value = scrlMonths.Value; break;
				case 4: spnMthsL4.Value = scrlMonths.Value; break;
			}
			cmbMonths.SelectedIndex = 0;

			UpdateControls();
		}

		private void cmbMonths_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int		iVal=0;

			int iPrev = cmbMonths.SelectedIndex;
			switch ( cmbMonths.SelectedIndex )
			{
				case 0: return;			// ignore
				case 1: iVal = 12;		break;
				case 2: iVal = 24;		break;
				case 3: iVal = 36;		break;
				case 4: iVal = 48;		break;
				case 5: iVal = 60;		break;
				case 6: iVal = 72;		break;
				case 7: iVal = 120;		break;
				case 8: iVal = 180;		break;
				case 9: iVal = 240;		break;
				case 10: iVal = 360;	break;
				case 11: iVal = 480;	break;
			}

			switch ( iLoanIndex )
			{
				case 1: spnMthsL1.Value = iVal; break;
				case 2: spnMthsL2.Value = iVal; break;
				case 3: spnMthsL3.Value = iVal; break;
				case 4: spnMthsL4.Value = iVal; break;
			}
			scrlMonths.Value = iVal;

			// now restore selected value from above, since it will have been
			// changed by the handler for scrlMonths
			cmbMonths.SelectedIndex = iPrev;

			UpdateControls();
		}

		private void spnAmtL1_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 1 )
			{
				if ( spnAmtL1.Value < 1000000 )
					scrlAmount.Value = (int)spnAmtL1.Value / 10000;
				else
					scrlAmount.Value = 100;
			}

			UpdateControls();
		}

		private void spnMthsL1_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 1 )
			{
				cmbMonths.SelectedIndex = 0;
				scrlMonths.Value = (int)spnMthsL1.Value;
			}

			UpdateControls();
		}

		private void spnIntL1_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 1 )
			{
				cmbInterest.SelectedIndex = 0;
				scrlInterest.Value = (int)((double)spnIntL1.Value / 0.125);
			}

			UpdateControls();
		}

		private void cmbInterest_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			float		fVal=0;

			int iPrev = cmbInterest.SelectedIndex;
			switch ( cmbInterest.SelectedIndex )
			{
				case 0: return;			// ignore
				case 1: fVal = 0.0f;	break;
				case 2: fVal = 0.9f;	break;
				case 3: fVal = 1.9f;	break;
				case 4: fVal = 2.9f;	break;
				case 5: fVal = 3.0f;	break;
				case 6: fVal = 3.25f;	break;
				case 7: fVal = 3.5f;	break;
				case 8: fVal = 3.75f;	break;
				case 9: fVal = 4.0f;	break;
				case 10: fVal = 4.25f;	break;
				case 11: fVal = 4.5f;	break;
				case 12: fVal = 4.75f;	break;
				case 13: fVal = 5.0f;	break;
				case 14: fVal = 5.25f;	break;
				case 15: fVal = 5.5f;	break;
				case 16: fVal = 5.75f;	break;
				case 17: fVal = 6.0f;	break;
				case 18: fVal = 6.25f;	break;
				case 19: fVal = 6.5f;	break;
				case 20: fVal = 6.75f;	break;
				case 21: fVal = 7.0f;	break;
				case 22: fVal = 7.25f;	break;
				case 23: fVal = 7.5f;	break;
				case 24: fVal = 7.75f;	break;
				case 25: fVal = 8.0f;	break;
				case 26: fVal = 8.25f;	break;
				case 27: fVal = 8.5f;	break;
				case 28: fVal = 8.75f;	break;
				case 29: fVal = 9.0f;	break;
			}

			switch ( iLoanIndex )
			{
				case 1: spnIntL1.Value = (decimal)fVal; break;
				case 2: spnIntL2.Value = (decimal)fVal; break;
				case 3: spnIntL3.Value = (decimal)fVal; break;
				case 4: spnIntL4.Value = (decimal)fVal; break;
			}
			scrlInterest.Value = (int)fVal;

			// now restore selected value from above, since it will have been
			// changed by the handler for scrlInterest
			cmbInterest.SelectedIndex = iPrev;

			UpdateControls();
		}

		private void scrlInterest_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			float	fVal;

			fVal = (float)(scrlInterest.Value * 0.125);

			switch ( iLoanIndex )
			{
				case 1: spnIntL1.Value = (decimal)fVal; break;
				case 2: spnIntL2.Value = (decimal)fVal; break;
				case 3: spnIntL3.Value = (decimal)fVal; break;
				case 4: spnIntL4.Value = (decimal)fVal; break;
			}
			cmbInterest.SelectedIndex = 0;

			UpdateControls();
		}

		private void spnAmtL2_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 2 )
			{
				if ( spnAmtL2.Value < 1000000 )
					scrlAmount.Value = (int)spnAmtL2.Value / 10000;
				else
					scrlAmount.Value = 100;
			}

			UpdateControls();
		}

		private void spnAmtL3_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 3 )
			{
				if ( spnAmtL3.Value < 1000000 )
					scrlAmount.Value = (int)spnAmtL3.Value / 10000;
				else
					scrlAmount.Value = 100;
			}

			UpdateControls();
		}

		private void spnAmtL4_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 4 )
			{
				if ( spnAmtL4.Value < 1000000 )
					scrlAmount.Value = (int)spnAmtL4.Value / 10000;
				else
					scrlAmount.Value = 100;
			}

			UpdateControls();
		}

		private void spnMthsL2_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 2 )
			{
				cmbMonths.SelectedIndex = 0;
				scrlMonths.Value = (int)spnMthsL2.Value;
			}

			UpdateControls();
		}

		private void spnMthsL3_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 3 )
			{
				cmbMonths.SelectedIndex = 0;
				scrlMonths.Value = (int)spnMthsL3.Value;
			}

			UpdateControls();
		}

		private void spnMthsL4_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 4 )
			{
				cmbMonths.SelectedIndex = 0;
				scrlMonths.Value = (int)spnMthsL4.Value;
			}

			UpdateControls();
		}

		private void spnIntL2_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 2 )
			{
				cmbInterest.SelectedIndex = 0;
				scrlInterest.Value = (int)((double)spnIntL2.Value / 0.125);
			}

			UpdateControls();
		}

		private void spnIntL3_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 3 )
			{
				cmbInterest.SelectedIndex = 0;
				scrlInterest.Value = (int)((double)spnIntL3.Value / 0.125);
			}

			UpdateControls();
		}

		private void spnIntL4_ValueChanged(object sender, System.EventArgs e)
		{
			if ( iLoanIndex == 4 )
			{
				cmbInterest.SelectedIndex = 0;
				scrlInterest.Value = (int)((double)spnIntL4.Value / 0.125);
			}

			UpdateControls();
		}

		private void UpdateControls()
		{
			// for now we're just going to calculate the payment amount, eventually
			// it would be nice to be able to calculate any field when n-1 fields
			// have been entered

			// if we can calculate the loans, then do so
			if ( (spnAmtL1.Value > 0) && (spnMthsL1.Value > 0) )
			{
				txtPayL1.Text = CalcPayment( spnAmtL1.Value, spnMthsL1.Value, spnIntL1.Value );
				_taskModel.sLoan1Code = CreateSASLoanCode( spnAmtL1.Value, spnMthsL1.Value, spnIntL1.Value );
				DateTime dt = _taskModel.dtpStartL1;
				lblLastL1.Text = string.Format( "Last payment:\r\n{0}", dt.AddMonths( Convert.ToInt32(spnMthsL1.Value) ).ToShortDateString() );
			}
			else
				lblLastL1.Text = txtPayL1.Text = string.Empty;

			if ( (spnAmtL2.Value > 0) && (spnMthsL2.Value > 0) )
			{
				txtPayL2.Text = CalcPayment( spnAmtL2.Value, spnMthsL2.Value, spnIntL2.Value );
				_taskModel.sLoan2Code = CreateSASLoanCode( spnAmtL2.Value, spnMthsL2.Value, spnIntL2.Value );
				DateTime dt = _taskModel.dtpStartL2;
				lblLastL2.Text = string.Format( "Last payment:\r\n{0}", dt.AddMonths( Convert.ToInt32(spnMthsL2.Value) ).ToShortDateString() );
			}
			else
				lblLastL2.Text = txtPayL2.Text = string.Empty;

			if ( (spnAmtL3.Value > 0) && (spnMthsL3.Value > 0) )
			{
				txtPayL3.Text = CalcPayment( spnAmtL3.Value, spnMthsL3.Value, spnIntL3.Value );
				_taskModel.sLoan3Code = CreateSASLoanCode( spnAmtL3.Value, spnMthsL3.Value, spnIntL3.Value );
				DateTime dt = _taskModel.dtpStartL3;
				lblLastL3.Text = string.Format( "Last payment:\r\n{0}", dt.AddMonths( Convert.ToInt32(spnMthsL3.Value) ).ToShortDateString() );
			}
			else
				lblLastL3.Text = txtPayL3.Text = string.Empty;

			if ( (spnAmtL4.Value > 0) && (spnMthsL4.Value > 0) )
			{
				txtPayL4.Text = CalcPayment( spnAmtL4.Value, spnMthsL4.Value, spnIntL4.Value );
				_taskModel.sLoan4Code = CreateSASLoanCode( spnAmtL4.Value, spnMthsL4.Value, spnIntL4.Value );
				DateTime dt = _taskModel.dtpStartL4;
				lblLastL4.Text = string.Format( "Last payment:\r\n{0}", dt.AddMonths( Convert.ToInt32(spnMthsL4.Value) ).ToShortDateString() );
			}
			else
				lblLastL4.Text = txtPayL4.Text = string.Empty;

			// keep displayed SAS code current
			if ( ckbCode.Checked )
			{
				_frmCode.lblCode.Text = _taskModel.SasCode;
			}
		}

		private string CalcPayment( decimal decAmt, decimal decMths, decimal decInt )
		{
			double	dAmt = Convert.ToDouble( decAmt );
			int		iMths = Convert.ToInt32( decMths );
			double	dInt = Convert.ToDouble( decInt );
			double	dPay, dInt1;

			if ( dInt > 0.0 )
			{
				
				// change to percentage
				dInt /= 1200;
				dInt1 = dInt + 1.0;

				dPay = dAmt * (dInt * Math.Pow(dInt1, iMths)) / (Math.Pow(dInt1,iMths) - 1);
			}
			else
				dPay = dAmt / iMths;

			return dPay.ToString("N2");
		}

		private string CreateSASLoanCode( decimal decAmt, decimal decMths, decimal decInt )
		{
			StringBuilder sb = new StringBuilder();	
			
			sb.AppendFormat( "\tfixed amount={0} rate={1} life={2};\r\n", decAmt.ToString(), decInt.ToString(), decMths.ToString() );

			return sb.ToString();
		}

		private void ckbOG1_CheckedChanged(object sender, System.EventArgs e)
		{
			_taskModel.bBasicInfo = ckbOG1.Checked;
			UpdateControls();
		}

		private void ckbOG2_CheckedChanged(object sender, System.EventArgs e)
		{
			_taskModel.bAmortTable = ckbOG2.Checked;
			UpdateControls();
		}

		private void ckbOG3_CheckedChanged(object sender, System.EventArgs e)
		{
			_taskModel.bCompare = ckbOG3.Checked;
			UpdateControls();
		}

		private void ckbOG4_CheckedChanged(object sender, System.EventArgs e)
		{
			_taskModel.bPayGraph = ckbOG4.Checked;
			UpdateControls();
		}

		private void ckbCode_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( ckbCode.Checked )
			{
				// Show the default form for this custom task
				_frmCode = new CodeForm( _taskModel.SasCode );
				_frmCode.Show();
			}
			else
				_frmCode.Close();
		}

		private void dtpStart_ValueChanged(object sender, System.EventArgs e)
		{
			switch ( iLoanIndex )
			{
				case 1: _taskModel.dtpStartL1 = dtpStart.Value; break;
				case 2: _taskModel.dtpStartL2 = dtpStart.Value; break;
				case 3: _taskModel.dtpStartL3 = dtpStart.Value; break;
				case 4: _taskModel.dtpStartL4 = dtpStart.Value; break;
			}

			UpdateControls();
		}
	}
}
