//--------------------------------------------------------------------------------
// Copyright (c) 2006 by SAS Institute Inc, Cary NC 27513 USA 
// 
// MergeDataHelpForm.cs
//
// Type:	C# Source Code
// Product: Custom Task for use in SAS Enterprise Guide or 
//          the SAS Add-In for Microsoft Office
//--------------------------------------------------------------------------------

#region // Namespaces  
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Resources;
#endregion // Namespaces  

namespace SAS.CustomTasks.MergeData
{
	/// <summary>
	/// MergeDataHelpForm.cs displays help information to the user for the MergeData Custom Example task.
	/// </summary>
	public class MergeDataHelpForm2 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.RichTextBox HelpRichTextBox;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		#region // MergeDataHelpForm  
		public MergeDataHelpForm2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


			//
			//  Load the rich text for the help dialog.
			//

			// get a reference to the current assembly
			System.Reflection.Assembly a = System.Reflection.Assembly.GetExecutingAssembly();
        
			// get he help file resource from the manifest
			System.IO.Stream stream = a.GetManifestResourceStream("SAS.CustomTasks.MergeData.MergeDataHelp.rtf");
			
			// load the file stream into the textbox
			HelpRichTextBox.LoadFile(stream, RichTextBoxStreamType.RichText);

		}
		#endregion // MergeDataHelpForm  


		#region // Dispose  
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion // Dispose  


		#region // Windows Form Designer generated code  
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MergeDataHelpForm2));
			this.HelpRichTextBox = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// HelpRichTextBox
			// 
			this.HelpRichTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.HelpRichTextBox.CausesValidation = false;
			this.HelpRichTextBox.Location = new System.Drawing.Point(0, 0);
			this.HelpRichTextBox.Name = "HelpRichTextBox";
			this.HelpRichTextBox.ReadOnly = true;
			this.HelpRichTextBox.Size = new System.Drawing.Size(691, 544);
			this.HelpRichTextBox.TabIndex = 0;
			this.HelpRichTextBox.Text = "";
			this.HelpRichTextBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataHelpForm2_KeyUp);
			// 
			// MergeDataHelpForm2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(692, 562);
			this.Controls.Add(this.HelpRichTextBox);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(300, 300);
			this.Name = "MergeDataHelpForm2";
			this.ShowInTaskbar = false;
			this.Text = "MergeData Help";
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataHelpForm2_KeyUp);
			this.ResumeLayout(false);

		}
		#endregion // Windows Form Designer generated code  


		#region // MergeDataHelpForm2_KeyUp  
		private void MergeDataHelpForm2_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			// Close the help window when the user hits the Escape key
			if (e.KeyCode == Keys.Escape)
				Close();
		}
		#endregion // MergeDataHelpForm2_KeyUp  

	}
}
