//--------------------------------------------------------------------------------
// Copyright (c) 2006 by SAS Institute Inc, Cary NC 27513 USA 
// 
// MergeDataTaskForm.cs
//
// Type:	C# Source Code
// Product: Custom Task for use in SAS Enterprise Guide or 
//          the SAS Add-In for Microsoft Office
//-------------------------------------------------------------------------------


#region // Namespaces 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using SAS.Shared.AddIns;
#endregion // Namespaces 

namespace SAS.CustomTasks.MergeData
{
	/// <summary>
	/// Summary description for MergeDataTaskForm.
	/// </summary>
	public class MergeDataTaskForm : System.Windows.Forms.Form
	{

		#region // Variables 
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.ComboBox CommonMergeVariableComboBox;
		private System.Windows.Forms.ListBox DataToMergeListBox;
		private System.Windows.Forms.Label CommonMergeVariableLabel;
		private System.Windows.Forms.Button AddDataButton;
		private System.Windows.Forms.Button RemoveDataButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		private string _LastServer = string.Empty;
		private System.Windows.Forms.RadioButton CommonVariableMergeRadioButton;
		private System.Windows.Forms.RadioButton DatasetOrderMergeRadioButton;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox DataToMergeGroupBox;
		private System.Windows.Forms.Button btnHelp;
		private System.Windows.Forms.Label MergeDataLabel;
		internal System.Windows.Forms.GroupBox OutputLocationGroupBox;
		internal System.Windows.Forms.Label OutputLibraryLabel;
		internal System.Windows.Forms.Label OutputServerLabel;
		internal System.Windows.Forms.ComboBox OutputLibraryComboBox;
		internal System.Windows.Forms.ComboBox OutputServerComboBox;
		private string _LastLibrary = string.Empty;
		internal System.Windows.Forms.Label OutputNameLabel;
		private System.Windows.Forms.RadioButton MasterTransactionRadioButton;
		private System.Windows.Forms.RadioButton CommonVariableMergeOutputMatchesRadioButton;
		private System.Windows.Forms.TextBox OutputMemberTextBox;

		#endregion // Variables 


		#region // Constructor 
		public MergeDataTaskForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();			

			UpdateRemoveDataButtonEnabledState();			

			CommonMergeVariableComboBox.Text = "There are no common variables.";
			CommonMergeVariableComboBox.Enabled = false;
			AddDataButton.Select();

			SASCodeValidity();
		}
		#endregion // Constructor 


		#region // Dispose 
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion // Dispose 


		#region // Windows Form Designer generated code  
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MergeDataTaskForm));
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.CommonMergeVariableComboBox = new System.Windows.Forms.ComboBox();
			this.DataToMergeListBox = new System.Windows.Forms.ListBox();
			this.CommonMergeVariableLabel = new System.Windows.Forms.Label();
			this.AddDataButton = new System.Windows.Forms.Button();
			this.RemoveDataButton = new System.Windows.Forms.Button();
			this.CommonVariableMergeRadioButton = new System.Windows.Forms.RadioButton();
			this.DatasetOrderMergeRadioButton = new System.Windows.Forms.RadioButton();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.MasterTransactionRadioButton = new System.Windows.Forms.RadioButton();
			this.CommonVariableMergeOutputMatchesRadioButton = new System.Windows.Forms.RadioButton();
			this.DataToMergeGroupBox = new System.Windows.Forms.GroupBox();
			this.btnHelp = new System.Windows.Forms.Button();
			this.MergeDataLabel = new System.Windows.Forms.Label();
			this.OutputLocationGroupBox = new System.Windows.Forms.GroupBox();
			this.OutputMemberTextBox = new System.Windows.Forms.TextBox();
			this.OutputLibraryComboBox = new System.Windows.Forms.ComboBox();
			this.OutputLibraryLabel = new System.Windows.Forms.Label();
			this.OutputServerComboBox = new System.Windows.Forms.ComboBox();
			this.OutputServerLabel = new System.Windows.Forms.Label();
			this.OutputNameLabel = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.DataToMergeGroupBox.SuspendLayout();
			this.OutputLocationGroupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(248, 520);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 3;
			this.btnOK.Text = "OK";
			this.btnOK.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(328, 520);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 4;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// CommonMergeVariableComboBox
			// 
			this.CommonMergeVariableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.CommonMergeVariableComboBox.Location = new System.Drawing.Point(16, 188);
			this.CommonMergeVariableComboBox.Name = "CommonMergeVariableComboBox";
			this.CommonMergeVariableComboBox.Size = new System.Drawing.Size(364, 21);
			this.CommonMergeVariableComboBox.TabIndex = 4;
			this.CommonMergeVariableComboBox.Text = "There are no common variables.";
			this.CommonMergeVariableComboBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.CommonMergeVariableComboBox.SelectedIndexChanged += new System.EventHandler(this.CommonMergeVariableComboBox_SelectedIndexChanged);
			// 
			// DataToMergeListBox
			// 
			this.DataToMergeListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DataToMergeListBox.Location = new System.Drawing.Point(16, 24);
			this.DataToMergeListBox.Name = "DataToMergeListBox";
			this.DataToMergeListBox.Size = new System.Drawing.Size(364, 121);
			this.DataToMergeListBox.TabIndex = 2;
			this.DataToMergeListBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.DataToMergeListBox.SelectedValueChanged += new System.EventHandler(this.DataToMergeListBox_SelectedValueChanged);
			// 
			// CommonMergeVariableLabel
			// 
			this.CommonMergeVariableLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.CommonMergeVariableLabel.Location = new System.Drawing.Point(16, 164);
			this.CommonMergeVariableLabel.Name = "CommonMergeVariableLabel";
			this.CommonMergeVariableLabel.Size = new System.Drawing.Size(364, 23);
			this.CommonMergeVariableLabel.TabIndex = 3;
			this.CommonMergeVariableLabel.Text = "Common &variable to merge:";
			// 
			// AddDataButton
			// 
			this.AddDataButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.AddDataButton.Location = new System.Drawing.Point(388, 24);
			this.AddDataButton.Name = "AddDataButton";
			this.AddDataButton.TabIndex = 0;
			this.AddDataButton.Text = "&Add...";
			this.AddDataButton.Click += new System.EventHandler(this.AddDataButton_Click);
			this.AddDataButton.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// RemoveDataButton
			// 
			this.RemoveDataButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.RemoveDataButton.Location = new System.Drawing.Point(388, 56);
			this.RemoveDataButton.Name = "RemoveDataButton";
			this.RemoveDataButton.TabIndex = 1;
			this.RemoveDataButton.Text = "&Remove";
			this.RemoveDataButton.Click += new System.EventHandler(this.RemoveDataButton_Click);
			this.RemoveDataButton.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// CommonVariableMergeRadioButton
			// 
			this.CommonVariableMergeRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.CommonVariableMergeRadioButton.Location = new System.Drawing.Point(8, 24);
			this.CommonVariableMergeRadioButton.Name = "CommonVariableMergeRadioButton";
			this.CommonVariableMergeRadioButton.Size = new System.Drawing.Size(460, 24);
			this.CommonVariableMergeRadioButton.TabIndex = 0;
			this.CommonVariableMergeRadioButton.Text = "Merge based on &common variable";
			this.CommonVariableMergeRadioButton.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.CommonVariableMergeRadioButton.CheckedChanged += new System.EventHandler(this.MergeOrderCheckedChanged);
			// 
			// DatasetOrderMergeRadioButton
			// 
			this.DatasetOrderMergeRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DatasetOrderMergeRadioButton.Location = new System.Drawing.Point(8, 96);
			this.DatasetOrderMergeRadioButton.Name = "DatasetOrderMergeRadioButton";
			this.DatasetOrderMergeRadioButton.Size = new System.Drawing.Size(460, 24);
			this.DatasetOrderMergeRadioButton.TabIndex = 1;
			this.DatasetOrderMergeRadioButton.Text = "Merge based on &dataset order";
			this.DatasetOrderMergeRadioButton.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.DatasetOrderMergeRadioButton.CheckedChanged += new System.EventHandler(this.MergeOrderCheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.CommonVariableMergeRadioButton);
			this.groupBox1.Controls.Add(this.DatasetOrderMergeRadioButton);
			this.groupBox1.Controls.Add(this.MasterTransactionRadioButton);
			this.groupBox1.Controls.Add(this.CommonVariableMergeOutputMatchesRadioButton);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(476, 128);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Merge Type";
			// 
			// MasterTransactionRadioButton
			// 
			this.MasterTransactionRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.MasterTransactionRadioButton.Location = new System.Drawing.Point(8, 72);
			this.MasterTransactionRadioButton.Name = "MasterTransactionRadioButton";
			this.MasterTransactionRadioButton.Size = new System.Drawing.Size(460, 24);
			this.MasterTransactionRadioButton.TabIndex = 1;
			this.MasterTransactionRadioButton.Text = "Merge based on &master data set";
			this.MasterTransactionRadioButton.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.MasterTransactionRadioButton.CheckedChanged += new System.EventHandler(this.MergeOrderCheckedChanged);
			// 
			// CommonVariableMergeOutputMatchesRadioButton
			// 
			this.CommonVariableMergeOutputMatchesRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.CommonVariableMergeOutputMatchesRadioButton.Location = new System.Drawing.Point(8, 48);
			this.CommonVariableMergeOutputMatchesRadioButton.Name = "CommonVariableMergeOutputMatchesRadioButton";
			this.CommonVariableMergeOutputMatchesRadioButton.Size = new System.Drawing.Size(460, 24);
			this.CommonVariableMergeOutputMatchesRadioButton.TabIndex = 0;
			this.CommonVariableMergeOutputMatchesRadioButton.Text = "Merge based on c&ommon variable, only outputting matches";
			// 
			// DataToMergeGroupBox
			// 
			this.DataToMergeGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DataToMergeGroupBox.Controls.Add(this.DataToMergeListBox);
			this.DataToMergeGroupBox.Controls.Add(this.AddDataButton);
			this.DataToMergeGroupBox.Controls.Add(this.CommonMergeVariableComboBox);
			this.DataToMergeGroupBox.Controls.Add(this.CommonMergeVariableLabel);
			this.DataToMergeGroupBox.Controls.Add(this.RemoveDataButton);
			this.DataToMergeGroupBox.Location = new System.Drawing.Point(8, 152);
			this.DataToMergeGroupBox.Name = "DataToMergeGroupBox";
			this.DataToMergeGroupBox.Size = new System.Drawing.Size(476, 224);
			this.DataToMergeGroupBox.TabIndex = 1;
			this.DataToMergeGroupBox.TabStop = false;
			this.DataToMergeGroupBox.Text = "Datasets to Merge";
			// 
			// btnHelp
			// 
			this.btnHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnHelp.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnHelp.Location = new System.Drawing.Point(408, 520);
			this.btnHelp.Name = "btnHelp";
			this.btnHelp.TabIndex = 5;
			this.btnHelp.Text = "&Help";
			this.btnHelp.Click += new System.EventHandler(this.btnHelp_Click);
			this.btnHelp.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// MergeDataLabel
			// 
			this.MergeDataLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.MergeDataLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.MergeDataLabel.ForeColor = System.Drawing.SystemColors.InfoText;
			this.MergeDataLabel.Location = new System.Drawing.Point(1, 554);
			this.MergeDataLabel.Name = "MergeDataLabel";
			this.MergeDataLabel.Size = new System.Drawing.Size(476, 23);
			this.MergeDataLabel.TabIndex = 6;
			this.MergeDataLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// OutputLocationGroupBox
			// 
			this.OutputLocationGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.OutputLocationGroupBox.Controls.Add(this.OutputMemberTextBox);
			this.OutputLocationGroupBox.Controls.Add(this.OutputLibraryComboBox);
			this.OutputLocationGroupBox.Controls.Add(this.OutputLibraryLabel);
			this.OutputLocationGroupBox.Controls.Add(this.OutputServerComboBox);
			this.OutputLocationGroupBox.Controls.Add(this.OutputServerLabel);
			this.OutputLocationGroupBox.Controls.Add(this.OutputNameLabel);
			this.OutputLocationGroupBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.OutputLocationGroupBox.Location = new System.Drawing.Point(8, 392);
			this.OutputLocationGroupBox.Name = "OutputLocationGroupBox";
			this.OutputLocationGroupBox.Size = new System.Drawing.Size(476, 112);
			this.OutputLocationGroupBox.TabIndex = 2;
			this.OutputLocationGroupBox.TabStop = false;
			this.OutputLocationGroupBox.Text = "Output location";
			// 
			// OutputMemberTextBox
			// 
			this.OutputMemberTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.OutputMemberTextBox.Location = new System.Drawing.Point(128, 76);
			this.OutputMemberTextBox.Name = "OutputMemberTextBox";
			this.OutputMemberTextBox.Size = new System.Drawing.Size(253, 20);
			this.OutputMemberTextBox.TabIndex = 5;
			this.OutputMemberTextBox.Text = "DataMerge";
			this.OutputMemberTextBox.TextChanged += new System.EventHandler(this.OutputMemberTextBox_TextChanged);
			this.OutputMemberTextBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			// 
			// OutputLibraryComboBox
			// 
			this.OutputLibraryComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.OutputLibraryComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.OutputLibraryComboBox.Location = new System.Drawing.Point(128, 48);
			this.OutputLibraryComboBox.Name = "OutputLibraryComboBox";
			this.OutputLibraryComboBox.Size = new System.Drawing.Size(253, 21);
			this.OutputLibraryComboBox.TabIndex = 3;
			this.OutputLibraryComboBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.OutputLibraryComboBox.SelectedIndexChanged += new System.EventHandler(this.OutputLibraryComboBox_SelectedIndexChanged);
			// 
			// OutputLibraryLabel
			// 
			this.OutputLibraryLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.OutputLibraryLabel.Location = new System.Drawing.Point(16, 50);
			this.OutputLibraryLabel.Name = "OutputLibraryLabel";
			this.OutputLibraryLabel.Size = new System.Drawing.Size(104, 16);
			this.OutputLibraryLabel.TabIndex = 2;
			this.OutputLibraryLabel.Text = "&Library:";
			// 
			// OutputServerComboBox
			// 
			this.OutputServerComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.OutputServerComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.OutputServerComboBox.Location = new System.Drawing.Point(128, 20);
			this.OutputServerComboBox.Name = "OutputServerComboBox";
			this.OutputServerComboBox.Size = new System.Drawing.Size(253, 21);
			this.OutputServerComboBox.TabIndex = 1;
			this.OutputServerComboBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.OutputServerComboBox.SelectedIndexChanged += new System.EventHandler(this.OutputServerComboBox_SelectedIndexChanged);
			// 
			// OutputServerLabel
			// 
			this.OutputServerLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.OutputServerLabel.Location = new System.Drawing.Point(16, 22);
			this.OutputServerLabel.Name = "OutputServerLabel";
			this.OutputServerLabel.Size = new System.Drawing.Size(104, 16);
			this.OutputServerLabel.TabIndex = 0;
			this.OutputServerLabel.Text = "&Server:";
			// 
			// OutputNameLabel
			// 
			this.OutputNameLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.OutputNameLabel.Location = new System.Drawing.Point(16, 78);
			this.OutputNameLabel.Name = "OutputNameLabel";
			this.OutputNameLabel.Size = new System.Drawing.Size(104, 16);
			this.OutputNameLabel.TabIndex = 4;
			this.OutputNameLabel.Text = "&Name:";
			// 
			// MergeDataTaskForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(492, 578);
			this.Controls.Add(this.OutputLocationGroupBox);
			this.Controls.Add(this.MergeDataLabel);
			this.Controls.Add(this.DataToMergeGroupBox);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.btnHelp);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(500, 552);
			this.Name = "MergeDataTaskForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Merge Data SAS Custom Task";
			this.Load += new System.EventHandler(this.MergeDataTaskForm_Load);
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.MergeDataTaskForm_KeyUp);
			this.groupBox1.ResumeLayout(false);
			this.DataToMergeGroupBox.ResumeLayout(false);
			this.OutputLocationGroupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion // Windows Form Designer generated code 


		#region // AddDataButton_Click 
		private void AddDataButton_Click(object sender, System.EventArgs e)
		{
			if (consumer != null )
			{

				#region // Let the user select the new data and add it to the list of data to merge  				
				
				ISASTaskConsumer2 tc2 = consumer as ISASTaskConsumer2;
				if (tc2 != null)
				{
					#region // Setup the default Server and Library for the File Open Dialog  
					ServerAccessMode serverAccessMode = ServerAccessMode.OneServer;
					if (( tc2.InputData != null) && (tc2.InputData.Length > 0) && ( DataToMergeListBox.Items.Count > 0))
					{
						// Get the default Server and Library location
						ISASTaskData ds = (ISASTaskData)tc2.InputData[tc2.InputData.Length - 1];
						if ( ds != null )
						{
							if (_LastServer == string.Empty)
								_LastServer = ds.Server;
							if (ds.Server != _LastServer || _LastLibrary == string.Empty)
								_LastLibrary = ds.Library;
						}
					}
					#endregion // Setup the default Server and Library for the FOD 


					#region // Display the FOD and get the selected datasets  
					string cookie = string.Empty;
					ISASTaskData[] inputDatasets = tc2.ShowInputDataSelector(this, DataSelectionMode.ReadOnlyMultipleInput, serverAccessMode, _LastServer, _LastLibrary, "", ref cookie);
								
					if (inputDatasets == null)
					{
						// Simply return if the data selector was cancelled.
						return;
					}
					else if (inputDatasets.Length <= 0)
					{
						// Simply return if the data selector was cancelled.
						return;
					}
					else if (inputDatasets[0] == null)
					{
						// Simply return if the data selector was cancelled.
						return;
					}
					else
					{
						// Store the Server and Libray location that the user selected
						_LastServer = inputDatasets[0].Server;
						_LastLibrary = inputDatasets[0].Library;
					}
					#endregion // Display the FOD and get the selected datasets  
			

					try
					{
						Cursor = Cursors.WaitCursor;			


						#region // Add the selected datasets to the input data collection and add the dataset names to the Files to Merge listbox  

						foreach (ISASTaskData istd in inputDatasets)
						{

							// Add dataset to the input data collection
							tc2.AddInputData(istd);

							// Add dataset name to the Files to Merge listbox
							int index = DataToMergeListBox.Items.Add(istd.File);

							// Make the newly added dataset name be the selected item.
							DataToMergeListBox.SelectedIndex = index;

							// Update the CommonMergeVariableComboBox to display the variables 
							// that are common to all the current datasets
							UpdateCommonMergeVariableComboBox();

							UpdateRemoveDataButtonEnabledState();

							SASCodeValidity();

						}					

						#endregion // Add the selected datasets to the input data collection and add the dataset names to the Files to Merge listbox  

					}
					finally
					{
						Cursor = Cursors.Default;
					}
			

				}

				#endregion // Let the user select the new data and add it to the list of data to merge  

			}

		} 
			
		#endregion // AddDataButton_Click 


		#region // RemoveDataButton_Click 
		private void RemoveDataButton_Click(object sender, System.EventArgs e)
		{
		
			int index = DataToMergeListBox.SelectedIndex;

			// Remove item from the DataToMergeListBox
			DataToMergeListBox.Items.RemoveAt(index);
			
			// Remove item from the Input data collection			
			ISASTaskConsumer2 tc2 = consumer as ISASTaskConsumer2;
			if (tc2 != null)
				tc2.RemoveInputData(tc2.InputData[index]);
			
			// Set the selected item to be the first item in the list
			int count = DataToMergeListBox.Items.Count;
			if ( count > 0 )
				DataToMergeListBox.SelectedIndex = 0;  

			// Only enable the common merge variable combobox if we have at least 2 items.
			if ( count < 2 )
			{
				CommonMergeVariableComboBox.Text = "There are no common variables.";
				CommonMergeVariableComboBox.Enabled = false;
			}

			// Update the CommonMergeVariableComboBox to display the variables 
			// that are common to all the current datasets
			UpdateCommonMergeVariableComboBox();

			UpdateRemoveDataButtonEnabledState();

			SASCodeValidity();

		}
		#endregion // RemoveDataButton_Click 


		#region // UpdateRemoveDataButtonEnabledState  
		private void UpdateRemoveDataButtonEnabledState()
		{
			if ( DataToMergeListBox.SelectedIndex == -1 )
				RemoveDataButton.Enabled = false;
			else
				RemoveDataButton.Enabled = true;			
		}
		#endregion // UpdateRemoveDataButtonEnabledState 
		
		
		#region // Properties for this add-in task  
		/// <summary>		
		/// ISASTaskConsumer, our hook to the host application for services
		/// </summary>		
		public SAS.Shared.AddIns.ISASTaskConsumer Consumer		
		{		
			set	{ consumer = value; }
		}
		private SAS.Shared.AddIns.ISASTaskConsumer consumer = null;

		private MergeDataTask _taskModel;
		public MergeDataTask taskModel
		{
			set { _taskModel = value; }
			get { return _taskModel; }
		}
		
		#endregion


		#region // CommonMergeVariableComboBox_SelectedIndexChanged  
		private void CommonMergeVariableComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
			taskModel.sID = CommonMergeVariableComboBox.SelectedItem.ToString();

			SASCodeValidity();
		}
		#endregion // CommonMergeVariableComboBox_SelectedIndexChanged  


		#region // UpdateCommonMergeVariableComboBox  
		private void UpdateCommonMergeVariableComboBox()
		{						

			// Reset the current items
			CommonMergeVariableComboBox.Items.Clear();

			if (( DataToMergeListBox.Items.Count > 1) &&  ( ((ISASTaskConsumer2)consumer).InputData.Length > 1 ))			
			{
			
				ArrayList CommonVars = new ArrayList();

				ISASTaskConsumer2 tc2 = consumer as ISASTaskConsumer2;
				if (tc2 == null) return;
				ISASTaskData istd = null;
		
				for ( int k=0; k < DataToMergeListBox.Items.Count ;k++ )
				{

					// Get the current task data			
					istd = tc2.InputData[k];
					if ( istd == null )
						return;

					istd.Accessor.Open();
					int colCount = istd.Accessor.ColumnCount;
								
					if ( k == 0 )
					{
						// Load the column names of the first dataset into the CommonVars ArrayList
						for (int j=0; j<colCount ;j++)
						{
							ISASTaskDataColumn dc = istd.Accessor.ColumnInfoByIndex(j);
							CommonVars.Add(dc.Name);	
						}
					}
					else
					{

						// Compare current dataset variable names to the common variable names
						ArrayList tempCommonVars = new ArrayList();
						for (int j=0; j<colCount; j++)
						{
							ISASTaskDataColumn dc = istd.Accessor.ColumnInfoByIndex(j);
							if ( (dc != null) && (CommonVars.Contains(dc.Name)) )
							{
								// This variable is common to all the data processed so far
								tempCommonVars.Add(dc.Name);	
							}
						}


						if ( tempCommonVars.Count == 0 )
						{
							CommonVars.Clear();
							break;
						}
						else
						{
							CommonVars.Clear();
							CommonVars.InsertRange(0, tempCommonVars.GetRange(0,tempCommonVars.Count));
						}

					}
					
				}


				if (CommonVars.Count == 0)
				{
					// There are no common variables.  														
					// Disable the Common Merge Variable controls					
					CommonMergeVariableComboBox.Items.Clear();
					CommonMergeVariableComboBox.Text = "There are no common variables.";
					CommonMergeVariableComboBox.Enabled = false;		

				}
				else
				{
					for (int i=0; i<CommonVars.Count ;i++)
					{
						CommonMergeVariableComboBox.Items.Add(CommonVars[i].ToString());
					}
					CommonMergeVariableComboBox.SelectedIndex = CommonVars.Count-1;

					CommonMergeVariableComboBox.Enabled = true;
					CommonMergeVariableLabel.Enabled = true;
				}

				SASCodeValidity();
			}
		}
		#endregion // UpdateCommonMergeVariableComboBox  


		#region // SASCodeValidity  
		private void SASCodeValidity()
		{

			string status = string.Empty;

			if (DataToMergeListBox.Items.Count < 2)
			{
				status = "There must be at least 2 datasets to merge.";
			}
			else 
			if ( ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariable ) ||
				 ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.MasterAndTransaction ) ||
				 ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariableMergeOutputMatches ) )
			{
				if (CommonMergeVariableComboBox.SelectedItem == null)				
				{
					status = "A common variable to merge must be selected.";
				}
				else if (CommonMergeVariableComboBox.SelectedItem.ToString() == string.Empty) 
				{
					status = "A common variable to merge must be selected.";
				}
			}

			if (status == string.Empty)
			{
				// Everything is OK  
				btnOK.Enabled = true;
				btnOK.Focus();
				MergeDataLabel.Text = string.Empty;
				CommonMergeVariableComboBox.Enabled = true;
				CommonMergeVariableLabel.Enabled = true;
			}
			else			
			{
				// There is a problem, disable the OK button and update the status bar  
				btnOK.Enabled = false;
				MergeDataLabel.Text = status;
			}


		}	
		#endregion // SASCodeValidity  


		#region // MergeDataTaskForm_Load  
		private void MergeDataTaskForm_Load(object sender, System.EventArgs e)
		{
		
			if (taskModel == null)
				return;

			#region // Add items to the Data to Merge listbox  
			ISASTaskConsumer2 tc2 = consumer as ISASTaskConsumer2;
			if (tc2 != null)
			{
				for (int i=0; i < tc2.InputData.Length; i++)
				{
					DataToMergeListBox.Items.Add(tc2.InputData[i].File.ToString());
				}
			}
			#endregion // Add items to the Data to Merge listbox  


			#region // Assign common ID variable if possible  
			if ( taskModel.sID != "" )
			{
				try
				{
					CommonMergeVariableComboBox.Items.Add(taskModel.sID);
					CommonMergeVariableComboBox.SelectedIndex = 0;
				}
				catch{}
			}
			#endregion // assign common ID variable if possible  


			#region // Load server list, library list and Member name  
			
			if ( LoadServers( taskModel.sOutputServer ) )
				LoadLibraries();

			OutputMemberTextBox.Text = taskModel.sOutputMemberName;

			#endregion // Load server list, library list and Member name


			#region // Set the selected Mergetype radio button  
			if ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariable )
			{
				CommonVariableMergeRadioButton.Checked = true;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else if ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariableMergeOutputMatches )
			{
				CommonVariableMergeOutputMatchesRadioButton.Checked = true;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else if ( taskModel.MergeType == SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.MasterAndTransaction )
			{
				MasterTransactionRadioButton.Checked = true;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else
			{				
				DatasetOrderMergeRadioButton.Checked = true;
				CommonMergeVariableComboBox.Visible = false;
				CommonMergeVariableLabel.Visible = false;
			}
			#endregion // Set the selected Mergetype radio button  
			

			SASCodeValidity();

		}
		#endregion // MergeDataTaskForm_Load  


		#region // Merge Order Checked Changed  
		private void MergeOrderCheckedChanged(object sender, System.EventArgs e)
		{			
			if ( CommonVariableMergeRadioButton.Checked )
			{
				taskModel.MergeType = SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariable;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else if ( CommonVariableMergeOutputMatchesRadioButton.Checked )
			{
				taskModel.MergeType = SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.CommonVariableMergeOutputMatches;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else if ( MasterTransactionRadioButton.Checked )
			{
				taskModel.MergeType = SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.MasterAndTransaction;
				CommonMergeVariableComboBox.Visible = true;
				CommonMergeVariableLabel.Visible = true;
			}
			else
			{
				taskModel.MergeType = SAS.CustomTasks.MergeData.MergeDataTask.eMergeType.DatasetOrder;		
				CommonMergeVariableComboBox.Visible = false;
				CommonMergeVariableLabel.Visible = false;
			}

			SASCodeValidity();
		}
		#endregion // Merge Order Checked Changed  


		#region // LoadServers  

		private bool LoadServers( string newServer )
		{

			string[] serverList;

			if ( ( consumer == null ) || ( consumer.Servers(out serverList) <=0 ) )
			{
				OutputServerComboBox.Items.Clear();
				return false;
			}

				
			OutputServerComboBox.Items.Clear();

			int currentServerItem = -1;
			int localServerItem = -1;

			foreach ( string serverName in serverList )
			{
				OutputServerComboBox.Items.Add(serverName.Trim());
			
				if (serverName.Trim() == newServer.Trim()) 
					currentServerItem = OutputServerComboBox.Items.Count -1;

				if ( serverName.Trim().ToUpper() == "LOCAL" )
					localServerItem = OutputServerComboBox.Items.Count -1;
			}


			if ( currentServerItem == -1 )
			{
				if ( localServerItem == -1 )
				{
					OutputServerComboBox.SelectedIndex = -1;
					return false;
				}

				taskModel.sOutputServer = OutputServerComboBox.Items[localServerItem].ToString();
				OutputServerComboBox.SelectedIndex = localServerItem;
			}
			else
			{
				taskModel.sOutputServer = newServer.Trim();
				OutputServerComboBox.SelectedIndex = currentServerItem;
			}
			return true;

		}
		#endregion // LoadServers  
		
		
		#region // LoadLibraries  
		private bool LoadLibraries()
		{


			if ( consumer == null )				
				throw new System.Exception("No libraries are available!");

			ISASTaskConsumer2 consumer2 = consumer as ISASTaskConsumer2;
			if ( consumer2 == null )
				throw new System.Exception("Unable to obtain an ISASTaskConsumer2 interface from the supplied consumer.");

			string[] libraryList;

			int librariesAvailable = 0;
			try
			{
			librariesAvailable = consumer2.Libraries( taskModel.sOutputServer, SAS.Shared.AddIns.LibraryType.ReadWrite, out libraryList );

			OutputLibraryComboBox.Items.Clear();

			int currentLibraryItem = -1;
			int workLibraryItem = -1;
			foreach ( string libraryName in libraryList )
			{
				OutputLibraryComboBox.Items.Add(libraryName.Trim());

				if (libraryName.Trim().ToUpper() == taskModel.sOutputLibrary)
					currentLibraryItem = OutputLibraryComboBox.Items.Count - 1;

				if (libraryName.Trim().ToUpper() == "WORK")
					workLibraryItem = OutputLibraryComboBox.Items.Count - 1;
			}

			if ( currentLibraryItem != -1 )
				OutputLibraryComboBox.SelectedIndex = currentLibraryItem;
			else
				OutputLibraryComboBox.SelectedIndex = workLibraryItem;

			if  ( (currentLibraryItem == -1) && (workLibraryItem == -1) )
				return false;

			MergeDataLabel.Text = string.Empty;
		 
			}
			catch
			{
                OutputLibraryComboBox.Items.Clear();
                MergeDataLabel.Text = "Unable to access server and its libraries.";
			}
			return true;

		}
		#endregion // LoadLibraries


		#region // btnHelp_Click  
		private void btnHelp_Click(object sender, System.EventArgs e)
		{

			// Display help information 
			MergeDataHelpForm2 hf = new MergeDataHelpForm2();
			hf.ShowDialog();

		}
		#endregion // btnHelp_Click  


		#region // OutputServerComboBox_SelectedIndexChanged  
		private void OutputServerComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{

			//  Load the writeable libraries on the newly selected server
			taskModel.sOutputServer = OutputServerComboBox.SelectedItem.ToString().Trim();
			LoadLibraries();

		}
		#endregion // OutputServerComboBox_SelectedIndexChanged  


		#region // OutputLibraryComboBox_SelectedIndexChanged  
		private void OutputLibraryComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{			

			// Get the newly selected library name  
			string OutputLibrary = OutputLibraryComboBox.SelectedItem.ToString().Trim();


			if ( OutputLibrary == string.Empty )
				taskModel.sOutputLibrary = "WORK";  // We have a blank library name, use the WORK library
			else
				taskModel.sOutputLibrary = OutputLibrary; // Use the newly selected library
		}
		#endregion // OutputLibraryComboBox_SelectedIndexChanged  


		#region // OutputMemberTextBox_TextChanged  
		private void OutputMemberTextBox_TextChanged(object sender, System.EventArgs e)
		{
			taskModel.sOutputMemberName = OutputMemberTextBox.Text.ToString().Trim();
		}
		#endregion // OutputMemberTextBox_TextChanged  


		#region // DataToMergeListBox_SelectedValueChanged  
		private void DataToMergeListBox_SelectedValueChanged(object sender, System.EventArgs e)
		{
			if ( DataToMergeListBox.SelectedItems.Count > 0 )
				RemoveDataButton.Enabled = true;
			else
				RemoveDataButton.Enabled = false;
		}
		#endregion // DataToMergeListBox_SelectedValueChanged  


		#region // MergeDataTaskForm_KeyUp  
		private void MergeDataTaskForm_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			// Display help when the user hits the F1 key
			if (e.KeyCode == Keys.F1)
				btnHelp_Click(sender, e);
		}
		#endregion // MergeDataTaskForm_KeyUp  

	}
}
