using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using SAS.Shared.AddIns;

namespace SAS.CustomTasks.PairedBar
{
	/// <summary>
	/// Summary description for PairedBarForm.
	/// </summary>
	public class PairedBarForm : System.Windows.Forms.Form
	{
		private string	sChartRole="Variable to chart";
		private string	sGroup1Role="Group1";
		private string	sGroup2Role="Group2";
		private bool	bUserSetTitle=false;

		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private SAS.EG.Controls.SASVariableSelector sasVariableSelector1;
		private SAS.EG.Controls.SASDragAndDropAnimation sasDragAndDropAnimation1;
		private System.Windows.Forms.GroupBox groupBox1;
		internal System.Windows.Forms.Label Label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtFootnote;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtTitle;
		private System.Windows.Forms.GroupBox groupBox2;
		internal System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox3;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.NumericUpDown numericUpDown2;
		private SAS.SharedUI.Controls.SASColorSelector clrGroup1;
		private SAS.SharedUI.Controls.SASColorSelector clrGroup2;
		private System.Windows.Forms.CheckBox ckb3D;
	
		#region Properties for this add-in task
		private ISASTaskConsumer _consumer;
		public ISASTaskConsumer consumer
		{
			set { _consumer = value; }
		}

		private PairedBar _taskModel;
		public PairedBar taskModel
		{
			set { _taskModel = value; }
		}
		#endregion

		public PairedBarForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.sasVariableSelector1 = new SAS.EG.Controls.SASVariableSelector();
			this.sasDragAndDropAnimation1 = new SAS.EG.Controls.SASDragAndDropAnimation();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.txtFootnote = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtTitle = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.label8 = new System.Windows.Forms.Label();
			this.ckb3D = new System.Windows.Forms.CheckBox();
			this.label9 = new System.Windows.Forms.Label();
			this.numericUpDown2 = new System.Windows.Forms.NumericUpDown();
			this.clrGroup1 = new SAS.SharedUI.Controls.SASColorSelector();
			this.clrGroup2 = new SAS.SharedUI.Controls.SASColorSelector();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).BeginInit();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(368, 453);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(72, 23);
			this.btnOK.TabIndex = 21;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(456, 453);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 23);
			this.btnCancel.TabIndex = 22;
			this.btnCancel.Text = "Cancel";
			// 
			// sasVariableSelector1
			// 
			this.sasVariableSelector1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.sasVariableSelector1.CacheDirtyFlag = false;
			this.sasVariableSelector1.CachePath = null;
			this.sasVariableSelector1.ColumnRolesTitle = "";
			this.sasVariableSelector1.ColumnsToAssignTitle = "";
			this.sasVariableSelector1.Location = new System.Drawing.Point(8, 40);
			this.sasVariableSelector1.Name = "sasVariableSelector1";
			this.sasVariableSelector1.Size = new System.Drawing.Size(376, 160);
			this.sasVariableSelector1.SortVariablesBy = SAS.EG.Controls.VARSORT.DataOrder;
			this.sasVariableSelector1.SortVariablesOrder = System.Windows.Forms.SortOrder.Ascending;
			this.sasVariableSelector1.TabIndex = 2;
			this.sasVariableSelector1.VariableDeassigned += new SAS.EG.Controls.SASVariableSelector.VariableDeassignedEventHandler(this.sasVariableSelector1_VariableDeassigned);
			this.sasVariableSelector1.VariableAssigned += new SAS.EG.Controls.SASVariableSelector.VariableAssignedEventHandler(this.sasVariableSelector1_VariableAssigned);
			// 
			// sasDragAndDropAnimation1
			// 
			this.sasDragAndDropAnimation1.AccessibleDescription = "An animated graphic depicting a variable being selected and then dragged over a r" +
				"ole before being dropped.";
			this.sasDragAndDropAnimation1.AccessibleRole = System.Windows.Forms.AccessibleRole.Graphic;
			this.sasDragAndDropAnimation1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.sasDragAndDropAnimation1.Location = new System.Drawing.Point(400, 56);
			this.sasDragAndDropAnimation1.Name = "sasDragAndDropAnimation1";
			this.sasDragAndDropAnimation1.RunAnimation = true;
			this.sasDragAndDropAnimation1.Size = new System.Drawing.Size(128, 116);
			this.sasDragAndDropAnimation1.TabIndex = 3;
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Location = new System.Drawing.Point(8, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(528, 3);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(8, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(144, 16);
			this.Label1.TabIndex = 0;
			this.Label1.Text = "Task Roles";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 296);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 8;
			this.label4.Text = "&Footnote:";
			// 
			// txtFootnote
			// 
			this.txtFootnote.Location = new System.Drawing.Point(64, 292);
			this.txtFootnote.Name = "txtFootnote";
			this.txtFootnote.Size = new System.Drawing.Size(472, 20);
			this.txtFootnote.TabIndex = 9;
			this.txtFootnote.Text = "";
			this.txtFootnote.TextChanged += new System.EventHandler(this.txtFootnote_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 264);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "&Title:";
			// 
			// txtTitle
			// 
			this.txtTitle.Location = new System.Drawing.Point(64, 260);
			this.txtTitle.Name = "txtTitle";
			this.txtTitle.Size = new System.Drawing.Size(472, 20);
			this.txtTitle.TabIndex = 7;
			this.txtTitle.Text = "";
			this.txtTitle.TextChanged += new System.EventHandler(this.txtTitle_TextChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(8, 248);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(528, 3);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 232);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(144, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Task Title and Footnote";
			// 
			// groupBox3
			// 
			this.groupBox3.Location = new System.Drawing.Point(8, 360);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(528, 3);
			this.groupBox3.TabIndex = 11;
			this.groupBox3.TabStop = false;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(8, 344);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(144, 16);
			this.label5.TabIndex = 10;
			this.label5.Text = "Graph Options";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 376);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 16);
			this.label6.TabIndex = 12;
			this.label6.Text = "Group &1 bar color:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(264, 376);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(104, 16);
			this.label7.TabIndex = 14;
			this.label7.Text = "Group &2 bar color:";
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(168, 404);
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(104, 20);
			this.numericUpDown1.TabIndex = 17;
			this.numericUpDown1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			this.numericUpDown1.Validating += new System.ComponentModel.CancelEventHandler(this.numericUpDown1_Validating);
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 408);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(160, 16);
			this.label8.TabIndex = 16;
			this.label8.Text = "&Maximum reference line value:";
			// 
			// ckb3D
			// 
			this.ckb3D.Location = new System.Drawing.Point(8, 440);
			this.ckb3D.Name = "ckb3D";
			this.ckb3D.Size = new System.Drawing.Size(152, 24);
			this.ckb3D.TabIndex = 20;
			this.ckb3D.Text = "Display &graph in 3D";
			this.ckb3D.CheckedChanged += new System.EventHandler(this.ckb3D_CheckedChanged);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(296, 408);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(184, 16);
			this.label9.TabIndex = 18;
			this.label9.Text = "&Number of reference line intervals:";
			// 
			// numericUpDown2
			// 
			this.numericUpDown2.Location = new System.Drawing.Point(480, 404);
			this.numericUpDown2.Maximum = new System.Decimal(new int[] {
																		   10000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Name = "numericUpDown2";
			this.numericUpDown2.Size = new System.Drawing.Size(56, 20);
			this.numericUpDown2.TabIndex = 19;
			this.numericUpDown2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDown2.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			this.numericUpDown2.Validating += new System.ComponentModel.CancelEventHandler(this.numericUpDown2_Validating);
			this.numericUpDown2.ValueChanged += new System.EventHandler(this.numericUpDown2_ValueChanged);
			// 
			// clrGroup1
			// 
			this.clrGroup1.Location = new System.Drawing.Point(112, 372);
			this.clrGroup1.Name = "clrGroup1";
			this.clrGroup1.ShowColorName = true;
			this.clrGroup1.Size = new System.Drawing.Size(32, 22);
			this.clrGroup1.TabIndex = 13;
			this.clrGroup1.ThemesEnabled = true;
			this.clrGroup1.ColorSelected += new SAS.SharedUI.Controls.SASColorSelector.ColorSelectedEventHandler(this.clrGroup1_ColorSelected);
			// 
			// clrGroup2
			// 
			this.clrGroup2.Location = new System.Drawing.Point(368, 372);
			this.clrGroup2.Name = "clrGroup2";
			this.clrGroup2.ShowColorName = true;
			this.clrGroup2.Size = new System.Drawing.Size(32, 22);
			this.clrGroup2.TabIndex = 15;
			this.clrGroup2.ThemesEnabled = true;
			this.clrGroup2.ColorSelected += new SAS.SharedUI.Controls.SASColorSelector.ColorSelectedEventHandler(this.clrGroup2_ColorSelected);
			// 
			// PairedBarForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(544, 487);
			this.Controls.Add(this.clrGroup2);
			this.Controls.Add(this.clrGroup1);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.numericUpDown2);
			this.Controls.Add(this.ckb3D);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.numericUpDown1);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.txtFootnote);
			this.Controls.Add(this.txtTitle);
			this.Controls.Add(this.sasDragAndDropAnimation1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.sasVariableSelector1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "PairedBarForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "set in code";
			this.Load += new System.EventHandler(this.PairedBarForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void PairedBarForm_Load(object sender, System.EventArgs e)
		{
			// Populate the available columns part of the variable selector
			ISASTaskData	data = _consumer.ActiveData;
			int		i;
			SAS.EG.Controls.SASVariableSelector.AddVariableParams varParms;
			ISASTaskDataColumn	colInfo;

			data.Accessor.Open();
			for ( i = 0; i < data.Accessor.ColumnCount; ++i )
			{
				colInfo = data.Accessor.ColumnInfoByIndex(i);
				varParms = GetVarParms(colInfo);
				sasVariableSelector1.AddVariable(varParms);
			}

			// Populate the roles part of the variable selector
			SAS.EG.Controls.SASVariableSelector.AddRoleParams	roleParms1 = new SAS.EG.Controls.SASVariableSelector.AddRoleParams();
			roleParms1.Name = sChartRole;
			roleParms1.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.All;
			roleParms1.MinNumVars = 1;
			roleParms1.MaxNumVars = 1;
			roleParms1.Unique = true;
			sasVariableSelector1.AddRole(roleParms1);

			SAS.EG.Controls.SASVariableSelector.AddRoleParams	roleParms2 = new SAS.EG.Controls.SASVariableSelector.AddRoleParams();
			roleParms2.Name = sGroup1Role;
			roleParms2.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.All;
			roleParms2.MinNumVars = 1;
			roleParms2.MaxNumVars = 1;
			roleParms2.Unique = true;
			sasVariableSelector1.AddRole(roleParms2);

			SAS.EG.Controls.SASVariableSelector.AddRoleParams	roleParms3 = new SAS.EG.Controls.SASVariableSelector.AddRoleParams();
			roleParms3.Name = sGroup2Role;
			roleParms3.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.All;
			roleParms3.MinNumVars = 1;
			roleParms3.MaxNumVars = 1;
			roleParms3.Unique = true;
			sasVariableSelector1.AddRole(roleParms3);

			data.Accessor.Close();

			numericUpDown1.Maximum = Decimal.MaxValue;
			numericUpDown2.Maximum = Decimal.MaxValue;

			// load task state
			txtTitle.Text = _taskModel.sTitle;
			txtFootnote.Text = _taskModel.sFootnote;

			// assign variables if possible
			if ( _taskModel.sChartVar != "" )
			{
				try
				{
					colInfo = data.Accessor.ColumnInfoByName( _taskModel.sChartVar );
					if ( colInfo != null )
						sasVariableSelector1.AssignVariable(sChartRole, _taskModel.sChartVar);
				}
				catch{}
			}

			if ( _taskModel.sGroup1Var != "" )
			{
				try
				{
					colInfo = data.Accessor.ColumnInfoByName( _taskModel.sGroup1Var );
					if ( colInfo != null )
						sasVariableSelector1.AssignVariable(sGroup1Role, _taskModel.sGroup1Var);
				}
				catch{}
			}

			if ( _taskModel.sGroup2Var != "" )
			{
				try
				{
					colInfo = data.Accessor.ColumnInfoByName( _taskModel.sGroup2Var );
					if ( colInfo != null )
						sasVariableSelector1.AssignVariable(sGroup2Role, _taskModel.sGroup2Var);
				}
				catch{}
			}

			clrGroup1.SetCurColor( _taskModel.clrGroup1 );
			clrGroup2.SetCurColor( _taskModel.clrGroup2 );
			ckb3D.Checked = _taskModel.b3D;
			numericUpDown1.Value = _taskModel.i64RefMax;
			numericUpDown2.Value = _taskModel.iIntervals;

			UpdateControls();
		}

		// Given an ISASTaskDataColumn, populate an AddVariableParams object
		private SAS.EG.Controls.SASVariableSelector.AddVariableParams GetVarParms( ISASTaskDataColumn colInfo )
		{
			SAS.EG.Controls.SASVariableSelector.AddVariableParams	varParms = new SAS.EG.Controls.SASVariableSelector.AddVariableParams();
			varParms.Name = colInfo.Name;
			varParms.Label = colInfo.Label;
			varParms.Format = colInfo.Format;
			varParms.Informat = colInfo.Format;
			varParms.MaxLength = colInfo.Length;

			// simple approach: if it's not character, treat as numeric
			if ( colInfo.Group == VariableGroup.Character )
				varParms.Type = SAS.EG.Controls.VARTYPE.Character;
			else 
				varParms.Type = SAS.EG.Controls.VARTYPE.Numeric;

			return varParms;
		}

		private void UpdateControls()
		{
			// GetNumberOfAssignedVariables can throw an exception if there are no variables assigned
			try
			{
				if ( (sasVariableSelector1.GetNumberOfAssignedVariables(sChartRole) == 1) &
					(sasVariableSelector1.GetNumberOfAssignedVariables(sGroup1Role) == 1) &
					(sasVariableSelector1.GetNumberOfAssignedVariables(sGroup2Role) == 1) )
				{
					btnOK.Enabled = true;
				}
				else
				{
					btnOK.Enabled = false;
				}
			}
			catch
				{
					btnOK.Enabled = false;
				}
		}

		private void sasVariableSelector1_VariableAssigned(object sender, SAS.EG.Controls.VariableAssignedEventArgs ea)
		{
			if ( ea.RoleName == sChartRole )
				_taskModel.sChartVar = ea.VarName;
			else if ( ea.RoleName == sGroup1Role )
				_taskModel.sGroup1Var = ea.VarName;
			else if ( ea.RoleName == sGroup2Role )
				_taskModel.sGroup2Var = ea.VarName;

			// if title hasn't been changed by user, then auto-generate a title for them
			if ( !bUserSetTitle )
			{
				string	sTmp;
				sTmp = string.Format( "Comparing {1} and {2} of {0}", _taskModel.sChartVar, _taskModel.sGroup1Var, _taskModel.sGroup2Var );
				_taskModel.sTitle = txtTitle.Text = sTmp;
				bUserSetTitle = false;
			}

			UpdateControls();
		}

		private void sasVariableSelector1_VariableDeassigned(object sender, SAS.EG.Controls.VariableDeassignedEventArgs ea)
		{
			if ( ea.RoleName == sChartRole )
				_taskModel.sChartVar = ea.VarName;
			else if ( ea.RoleName == sGroup1Role )
				_taskModel.sGroup1Var = ea.VarName;
			else if ( ea.RoleName == sGroup2Role )
				_taskModel.sGroup2Var = ea.VarName;

			// if title hasn't been changed by user, then auto-generate a title for them
			if ( !bUserSetTitle )
			{
				string	sTmp;
				sTmp = string.Format( "Comparing {1} and {2} of {0}", _taskModel.sChartVar, _taskModel.sGroup1Var, _taskModel.sGroup2Var );
				_taskModel.sTitle = txtTitle.Text = sTmp;
				bUserSetTitle = false;
			}

			UpdateControls();
		}

		private void txtTitle_TextChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.sTitle = txtTitle.Text;
			bUserSetTitle = true;
		}

		private void txtFootnote_TextChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.sFootnote = txtFootnote.Text;
		}

		private void clrGroup1_ColorSelected(object sender, SAS.SharedUI.Controls.SASColorSelector.ColorSelectedEventArgs csea)
		{
			// update model with new value
			string sOut;
			_taskModel.clrGroup1 = clrGroup1.GetCurColor( out sOut  );
			_taskModel.sClr1 = sOut;
		}

		private void clrGroup2_ColorSelected(object sender, SAS.SharedUI.Controls.SASColorSelector.ColorSelectedEventArgs csea)
		{
			// update model with new value
			string sOut;
			_taskModel.clrGroup2 = clrGroup2.GetCurColor( out sOut );
			_taskModel.sClr2 = sOut;
		}

		private void ckb3D_CheckedChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.b3D = ckb3D.Checked;
		}

		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.i64RefMax = Convert.ToInt64( numericUpDown1.Value );
		}

		private void numericUpDown2_ValueChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.iIntervals = Convert.ToInt32( numericUpDown2.Value );
		}

		private void numericUpDown1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			// update model with new value
			_taskModel.i64RefMax = Convert.ToInt64( numericUpDown1.Value );
		}

		private void numericUpDown2_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			// update model with new value
			_taskModel.iIntervals = Convert.ToInt32( numericUpDown2.Value );
		}
	}
}
