using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace SAS.CustomTasks.SPSS
{
	/// <summary>
	/// Summary description for SPSSForm.
	/// </summary>
	public class SPSSForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.TextBox tbFilePath;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button bBrowse;
		private String strFilePath;
		private String strFileName;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SPSSForm()
		{
			InitializeComponent();
			strFilePath = String.Empty;
			strFileName = String.Empty;
			openFileDialog1.Filter = "SPSS files (*.por)|*.por|All files (*.*)|*.*";
			openFileDialog1.CheckFileExists = true;
			openFileDialog1.CheckPathExists = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.tbFilePath = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.bBrowse = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(186, 72);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(269, 72);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			// 
			// tbFilePath
			// 
			this.tbFilePath.Location = new System.Drawing.Point(89, 46);
			this.tbFilePath.Name = "tbFilePath";
			this.tbFilePath.Size = new System.Drawing.Size(224, 20);
			this.tbFilePath.TabIndex = 3;
			this.tbFilePath.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(9, 46);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "File location:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// bBrowse
			// 
			this.bBrowse.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.bBrowse.Location = new System.Drawing.Point(312, 47);
			this.bBrowse.Name = "bBrowse";
			this.bBrowse.Size = new System.Drawing.Size(32, 19);
			this.bBrowse.TabIndex = 5;
			this.bBrowse.Text = "...";
			this.bBrowse.Click += new System.EventHandler(this.bBrowse_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 11);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(327, 23);
			this.label2.TabIndex = 6;
			this.label2.Text = "Please select the .por file you want convert via the SPSS Engine.";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// SPSSForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(348, 106);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.bBrowse);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.tbFilePath);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SPSSForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "SPSS";
			this.ResumeLayout(false);

		}
		#endregion

		private void bBrowse_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				tbFilePath.Text = openFileDialog1.FileName;
			}
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			FileInfo fi = new FileInfo(tbFilePath.Text);
			if (fi.Exists)
			{
				strFilePath = fi.FullName;
				strFileName = fi.Name.Replace(fi.Extension,"");
			}
			else
			{
				strFilePath = String.Empty;
				strFileName = String.Empty;
			}
		}

		public String FilePath
		{
			get
			{
				return strFilePath;
			}
			set
			{
				strFilePath = value;
				tbFilePath.Text = strFilePath;
			}
		}

		public String FileName
		{
			get
			{
				return strFileName;
			}
		}
	}
}
