using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SAS.CustomTasks.SimpleCodeEditor
{
	/// <summary>
	/// Summary description for SimpleCodeEditor.
	/// </summary>
	public class SimpleCodeEditorForm : System.Windows.Forms.Form
	{
		// interop class for the SAS enhanced editor control
		// requires reference to AxInterop.EDITORCONTROLLib.dll
		// and Interop.EDITORCONTROLLib.dll
		// both are C:\Program Files\SAS\Shared Files\BIClientTasks\3.0 by default 	
		private AxEDITORCONTROLLib.AxEditorControl ctlEditor = null;

		#region Properties for this add-in task
		private SimpleCodeEditor _taskModel;
		public SimpleCodeEditor taskModel
		{
			set { _taskModel = value; }
		}
		#endregion

		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Panel pnlPlaceHolder;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SimpleCodeEditorForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.pnlPlaceHolder = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(470, 462);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(558, 462);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			// 
			// pnlPlaceHolder
			// 
			this.pnlPlaceHolder.Location = new System.Drawing.Point(0, 0);
			this.pnlPlaceHolder.Name = "pnlPlaceHolder";
			this.pnlPlaceHolder.Size = new System.Drawing.Size(648, 448);
			this.pnlPlaceHolder.TabIndex = 3;
			this.pnlPlaceHolder.Visible = false;
			// 
			// SimpleCodeEditorForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 496);
			this.Controls.Add(this.pnlPlaceHolder);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SimpleCodeEditorForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "SAS Custom Task";
			this.Load += new System.EventHandler(this.SimpleCodeEditor_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void axEditorControl1_EditChange(object sender, System.EventArgs e)
		{
			_taskModel.sCode = ctlEditor.Text;
		}

		private void SimpleCodeEditor_Load(object sender, System.EventArgs e)
		{
			
			// creat the editor control
			ctlEditor = new AxEDITORCONTROLLib.AxEditorControl();
			ctlEditor.Location = pnlPlaceHolder.Location;
			ctlEditor.Size = pnlPlaceHolder.Size;
			ctlEditor.Visible = true;
			ctlEditor.Dock = pnlPlaceHolder.Dock;
			ctlEditor.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
			ctlEditor.EditChange += new System.EventHandler(this.ctlEditor_EditChange);

			// add handler for when the control is finished being created
			ctlEditor.HandleCreated += new EventHandler(ctlEditor_HandleCreated);

			this.Controls.AddRange(new System.Windows.Forms.Control[] {this.ctlEditor});
		}

		// control is created - now open file
		private void ctlEditor_HandleCreated(object sender, EventArgs e)
		{
			ctlEditor.SetLanguage(4); // set language to SAS for syntax coloring
			ctlEditor.Text = _taskModel.sCode;
		}

		private void ctlEditor_EditChange(object sender, System.EventArgs e)
		{
			 _taskModel.sCode = ctlEditor.Text;
		}
	}
}
