using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

namespace SAS.CustomTasks.ZipcodeDotMap
{
	/// <summary>
	/// dialog warning user that task may take a long time
	/// </summary>
	public class LongRunningWarningForm : System.Windows.Forms.Form
	{
		static private bool		bDontShow=false;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnOK;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LongRunningWarningForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LongRunningWarningForm));
			this.label1 = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(56, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(344, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "You may want to filter your data before running this add-in task.";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 16);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 2;
			this.pictureBox1.TabStop = false;
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(56, 88);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(240, 24);
			this.checkBox1.TabIndex = 3;
			this.checkBox1.Text = "Do not show this message again.";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(56, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(344, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Attempting to map zipcodes for multiple states can take a long time.";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(168, 136);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(72, 23);
			this.btnOK.TabIndex = 5;
			this.btnOK.Text = "OK";
			// 
			// LongRunningWarningForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 175);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "LongRunningWarningForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Long Running Time Warning";
			this.Load += new System.EventHandler(this.LongRunningWarningForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			// Note:  we don't actually store anything in the .ini file, we just use
			//		the existence of the file as the flag to show/not show the dialog

			if ( checkBox1.Checked )
				try 
				{
					// create the ini file
					StreamWriter sr = File.CreateText( Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + ZipcodeDotMap.strFileINI );
					sr.Close();
				}
				catch 
				{
					// if there were any problems, just keep track of the flag while EG is running
					bDontShow = true;
				}
			else
				try 
				{
					// change of heart, get rid of the file
					File.Delete( Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + ZipcodeDotMap.strFileINI );
				}
				catch 
				{
					bDontShow = false;
				}
		}

		private void LongRunningWarningForm_Load(object sender, System.EventArgs e)
		{
			// if we're using our internal flag, then just close the dialog
			if ( bDontShow )
				this.Close();
		}
	}
}
