using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

using SAS.Shared.AddIns;

namespace SAS.CustomTasks.ZipcodeDotMap
{
	/// <summary>
	/// main form for task, provides a variable selector and
	/// two edit fields for title & footnote
	/// </summary>
	public class ZipcodeDotMapForm : System.Windows.Forms.Form
	{
		private string	sZipRole="Zipcode";
		private string	sRespRole="Response value";
		private bool	bUserSetTitle=false;
	
		#region Properties for this add-in task
		private ISASTaskConsumer _consumer;
		public ISASTaskConsumer consumer
		{
			set { _consumer = value; }
		}

		private ZipcodeDotMap _taskModel;
		public ZipcodeDotMap taskModel
		{
			set { _taskModel = value; }
		}
		#endregion

		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		internal System.Windows.Forms.Label Label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private SAS.EG.Controls.SASVariableSelector sasVariableSelector1;
		private SAS.EG.Controls.SASDragAndDropAnimation sasDragAndDropAnimation1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.GroupBox groupBox2;
		internal System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtFootnote;
		private System.Windows.Forms.TextBox txtTitle;

		public ZipcodeDotMapForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ZipcodeDotMapForm));
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.Label1 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.sasVariableSelector1 = new SAS.EG.Controls.SASVariableSelector();
			this.sasDragAndDropAnimation1 = new SAS.EG.Controls.SASDragAndDropAnimation();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtTitle = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.txtFootnote = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(368, 365);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(72, 23);
			this.btnOK.TabIndex = 10;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(456, 365);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 23);
			this.btnCancel.TabIndex = 11;
			this.btnCancel.Text = "Cancel";
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(8, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(144, 16);
			this.Label1.TabIndex = 0;
			this.Label1.Text = "Task Roles";
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(8, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(528, 3);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			// 
			// sasVariableSelector1
			// 
			this.sasVariableSelector1.CacheDirtyFlag = false;
			this.sasVariableSelector1.CachePath = null;
			this.sasVariableSelector1.ColumnRolesTitle = "";
			this.sasVariableSelector1.ColumnsToAssignTitle = "";
			this.sasVariableSelector1.Location = new System.Drawing.Point(8, 40);
			this.sasVariableSelector1.Name = "sasVariableSelector1";
			this.sasVariableSelector1.Size = new System.Drawing.Size(376, 168);
			this.sasVariableSelector1.SortVariablesBy = SAS.EG.Controls.VARSORT.DataOrder;
			this.sasVariableSelector1.SortVariablesOrder = System.Windows.Forms.SortOrder.Ascending;
			this.sasVariableSelector1.TabIndex = 2;
			this.sasVariableSelector1.VariableDeassigned += new SAS.EG.Controls.SASVariableSelector.VariableDeassignedEventHandler(this.sasVariableSelector1_VariableDeassigned);
			this.sasVariableSelector1.VariableAssigned += new SAS.EG.Controls.SASVariableSelector.VariableAssignedEventHandler(this.sasVariableSelector1_VariableAssigned);
			// 
			// sasDragAndDropAnimation1
			// 
			this.sasDragAndDropAnimation1.AccessibleDescription = "An animated graphic depicting a variable being selected and then dragged over a r" +
				"ole before being dropped.";
			this.sasDragAndDropAnimation1.AccessibleRole = System.Windows.Forms.AccessibleRole.Graphic;
			this.sasDragAndDropAnimation1.Location = new System.Drawing.Point(400, 56);
			this.sasDragAndDropAnimation1.Name = "sasDragAndDropAnimation1";
			this.sasDragAndDropAnimation1.RunAnimation = true;
			this.sasDragAndDropAnimation1.Size = new System.Drawing.Size(128, 116);
			this.sasDragAndDropAnimation1.TabIndex = 3;
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(8, 248);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(528, 3);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 232);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(144, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Task Title and Footnote";
			// 
			// txtTitle
			// 
			this.txtTitle.Location = new System.Drawing.Point(8, 280);
			this.txtTitle.Name = "txtTitle";
			this.txtTitle.Size = new System.Drawing.Size(528, 20);
			this.txtTitle.TabIndex = 7;
			this.txtTitle.Text = "";
			this.txtTitle.TextChanged += new System.EventHandler(this.txtTitle_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 264);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "&Title:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 312);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(100, 16);
			this.label4.TabIndex = 8;
			this.label4.Text = "&Footnote:";
			// 
			// txtFootnote
			// 
			this.txtFootnote.Location = new System.Drawing.Point(8, 328);
			this.txtFootnote.Name = "txtFootnote";
			this.txtFootnote.Size = new System.Drawing.Size(528, 20);
			this.txtFootnote.TabIndex = 9;
			this.txtFootnote.Text = "";
			this.txtFootnote.TextChanged += new System.EventHandler(this.txtFootnote_TextChanged);
			// 
			// ZipcodeDotMapForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(544, 399);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.txtFootnote);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.txtTitle);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.sasDragAndDropAnimation1);
			this.Controls.Add(this.sasVariableSelector1);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ZipcodeDotMapForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "set in code";
			this.Load += new System.EventHandler(this.ZipcodeDotMapForm_Load);
			this.ResumeLayout(false);

		}
		#endregion
		
		// Given an ISASTaskDataColumn, populate an AddVariableParams object
		private SAS.EG.Controls.SASVariableSelector.AddVariableParams GetVarParms( ISASTaskDataColumn colInfo )
		{
			SAS.EG.Controls.SASVariableSelector.AddVariableParams	varParms = new SAS.EG.Controls.SASVariableSelector.AddVariableParams();
			varParms.Name = colInfo.Name;
			varParms.Label = colInfo.Label;
			varParms.Format = colInfo.Format;
			varParms.Informat = colInfo.Format;
			varParms.MaxLength = colInfo.Length;

			// simple approach: if it's not character, treat as numeric
			if ( colInfo.Group == VariableGroup.Character )
				varParms.Type = SAS.EG.Controls.VARTYPE.Character;
			else 
				varParms.Type = SAS.EG.Controls.VARTYPE.Numeric;

			return varParms;
		}


		// if all variables have been assigned, then enable the OK button
		private void UpdateControls()
		{
			// GetNumberOfAssignedVariables can throw an exception if there are no variables assigned
			try
			{
				if ( (sasVariableSelector1.GetNumberOfAssignedVariables(sZipRole) == 1) &
					(sasVariableSelector1.GetNumberOfAssignedVariables(sRespRole) == 1) )
				{
					btnOK.Enabled = true;
				}
				else
				{
					btnOK.Enabled = false;
				}
			}
			catch
			{
				btnOK.Enabled = false;
			}
		}

		private void sasVariableSelector1_VariableAssigned(object sender, SAS.EG.Controls.VariableAssignedEventArgs ea)
		{
			if ( ea.RoleName == sZipRole )
				_taskModel.sZipVar = ea.VarName;
			else if ( ea.RoleName == sRespRole )
			{
				_taskModel.sRespVar = ea.VarName;

				// if title hasn't been changed by user, then auto-generate a title for them
				if ( !bUserSetTitle )
				{
					string	sTmp;
					sTmp = string.Format( "Values of {0} by Zipcode", ea.VarName );
					_taskModel.sTitle = txtTitle.Text = sTmp;
					bUserSetTitle = false;
				}
			}

			UpdateControls();
		}

		private void sasVariableSelector1_VariableDeassigned(object sender, SAS.EG.Controls.VariableDeassignedEventArgs ea)
		{
			if ( ea.RoleName == sZipRole )
				_taskModel.sZipVar = ea.VarName;
			else if ( ea.RoleName == sRespRole )
			{
				_taskModel.sRespVar = ea.VarName;

				// if title hasn't been changed by user, then auto-generate a title for them
				if ( !bUserSetTitle )
				{
					_taskModel.sTitle = txtTitle.Text = "";
					bUserSetTitle = false;
				}
			}
			
			UpdateControls();
		}

		private void ZipcodeDotMapForm_Load(object sender, System.EventArgs e)
		{
			// check to see if they don't want to see the dialog
			if ( !File.Exists( Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + ZipcodeDotMap.strFileINI ) )
			{
				LongRunningWarningForm	frm = new LongRunningWarningForm();
				frm.ShowDialog();
			}

			// Populate the available columns part of the variable selector
			ISASTaskData	data = _consumer.ActiveData;
			int		i;
			SAS.EG.Controls.SASVariableSelector.AddVariableParams varParms;
			ISASTaskDataColumn	colInfo;

			data.Accessor.Open();
			for ( i = 0; i < data.Accessor.ColumnCount; ++i )
			{
				colInfo = data.Accessor.ColumnInfoByIndex(i);
				varParms = GetVarParms(colInfo);
				sasVariableSelector1.AddVariable(varParms);
			}

			// Populate the roles part of the variable selector
			SAS.EG.Controls.SASVariableSelector.AddRoleParams	roleParms1 = new SAS.EG.Controls.SASVariableSelector.AddRoleParams();
			roleParms1.Name = sZipRole;
			roleParms1.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.Numeric;
			roleParms1.MinNumVars = 1;
			roleParms1.MaxNumVars = 1;
			roleParms1.Unique = true;
			sasVariableSelector1.AddRole(roleParms1);

			SAS.EG.Controls.SASVariableSelector.AddRoleParams	roleParms2 = new SAS.EG.Controls.SASVariableSelector.AddRoleParams();
			roleParms2.Name = sRespRole;
			roleParms2.Type = SAS.EG.Controls.SASVariableSelector.ROLETYPE.Numeric;
			roleParms2.MinNumVars = 1;
			roleParms2.MaxNumVars = 1;
			roleParms2.Unique = true;
			sasVariableSelector1.AddRole(roleParms2);

			data.Accessor.Close();

			// load task state
			txtTitle.Text = _taskModel.sTitle;
			txtFootnote.Text = _taskModel.sFootnote;

			// assign variables if possible
			if ( _taskModel.sZipVar != "" )
			{
				try
				{
					colInfo = data.Accessor.ColumnInfoByName( _taskModel.sZipVar );
					if ( colInfo != null )
						sasVariableSelector1.AssignVariable(sZipRole, _taskModel.sZipVar);
				}
				catch{}
			}

			if ( _taskModel.sRespVar != "" )
			{
				try
				{
					colInfo = data.Accessor.ColumnInfoByName( _taskModel.sRespVar );
					if ( colInfo != null )
						sasVariableSelector1.AssignVariable(sRespRole, _taskModel.sRespVar);
				}
				catch{}
			}

			UpdateControls();
		}

		private void txtTitle_TextChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.sTitle = txtTitle.Text;
			bUserSetTitle = true;
		}

		private void txtFootnote_TextChanged(object sender, System.EventArgs e)
		{
			// update model with new value
			_taskModel.sFootnote = txtFootnote.Text;
		}
	}
}
